#ifndef xfonttool_h
# define xfonttool_h "@(#) $Id$"

/* structure to hold informtion about a font family */

/* The XLFD fields are:
 *
 * foundry xxx	(e.g. bitstream)
 * family xxx	(e.g. charter)
 * weight xxx	(e.g. bold, medium)
 * slant xxx	(r i or o for roman/italic/oblique)
 * setwidth xxx	(normal, condensed, etc.)
 * addedstyle xxx	(serif, sans, '' for none)
 * pixelsz N	(normally leave this as *) [also: pixelsize]
 * pointsize N	(font size in units of 1/727.2 of an inch, e.g. 120)
 * resx N		(x dots per inch, horizontal screen resolution)
 * resy N		(y dots per inch, vertical screen resolution)
 * space xxx	(m = monospaced, p = proportional, c = cell)
 * averagewidth N	(average character width in pixels)
 * registry rrr	(usually iso8859 or adobe)
 * encoding xxx	(usually 1 or 2 (for iso8859) or fontspecific)
 *
 * There are fourteen fields.
 *
 */

typedef struct {
    char *Fields[14];
    char *FullName;
    char *FullName2;
    char *PostScriptName;
} t_OneFont;

#define FIELD_FOUNDRY	0
#define FIELD_FAMILY	1
#define FIELD_WEIGHT	2
#define FIELD_SLANT	3
#define FIELD_SETWIDTH	4
#define FIELD_ADDEDSTYLE	5
#define FIELD_PIXELSZ	6
#define FIELD_POINTSIZE	7
#define FIELD_RESX	8
#define FIELD_RESY	9
#define FIELD_SPACE	10
#define FIELD_AVERAGEWIDTH	11
#define FIELD_REGISTRY	12
#define FIELD_ENCODING	13

#include "api.h"

extern char *progname;

/* some functions... */
char *firstLine(
#ifdef HAVE_PROTO
    char *string,
    int *lengthp
#endif
);

char *nextLine(
#ifdef HAVE_PROTO
    char *string,
    char *lastStart,
    int *lengthp
#endif
);

int fileNameToNumber(
#ifdef HAVE_PROTO
    char *name
#endif
);

char *EscapeString(
#ifdef HAVE_PROTO
    char *String
#endif
);

void FontNameToFields(
#ifdef HAVE_PROTO
    char *FontName,
    char **Fields
#endif
);

void FieldsToFontName(
#ifdef HAVE_PROTO
    char *FontName,
    char **Fields
#endif
);

void destroyFonts(
#ifdef HAVE_PROTO
    t_OneFont *Fonts,
    int n
#endif
);

char *updateConstraintPattern();

#ifndef NO_X_INCLUDES
int GetFontNamesMatching(
#ifdef HAVE_PROTO
    Display *dpy,
    char *pattern,
    t_OneFont **resultp
#endif
);
#endif

#endif /* xfonttool_h */
