#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <malloc.h>

#define NO_X_INCLUDES 1
#include "fonttool.h"

char *
firstLine(string, lengthp)
    char *string;
    int *lengthp;
{
    register char *p;

    *lengthp = 0;
    for (p = string; *p; p++) {
	if (*p == '\\' && p[1] == 'n') {
	    return string;
	}
	++*lengthp;
    }
    return string;
}

char *
nextLine(string, lastStart, lengthp)
    char *string;
    char *lastStart;
    int *lengthp;
{
    /* First measure the length of the current line,
     * so we can step over it.
     * We wouldn't need to do this if we trusted lengthp.
     */
    *lengthp = 0;
    (void) firstLine(lastStart, lengthp);
    if (!lastStart[*lengthp]) {
	/* no more */
	*lengthp = 0;
	return (char *) 0;
    }

    /* Now we need the next line in the sequence...
     * if there is one.
     */

    if (lastStart[*lengthp] == '\\' &&
	lastStart[*lengthp + 1] == 'n'
    ) {
	/* there's probably another line, as the first one ended in \n  */
	return firstLine(&lastStart[*lengthp + 2], lengthp);
    } else {
	/* How did we get here? */
	fprintf(stderr, "internal error %d in nextLine: 0x%x/[%c]\n",
	    *lengthp,
	    lastStart[*lengthp],
	    lastStart[*lengthp]
	);
	*lengthp = 0;
	return (char *) 0;
    }
}

char *
EscapeString(string)
    char *string;
{
    int newLength = 1; /* 1 for the trailing \0 */
    char *result;
    register char *p;
    char *q;

    for (p = string; *p; p++) {
	if (*p == '\n' || *p == '\\') {
	    newLength++;
	}
	newLength++;
    }

    q = result = malloc(newLength);

    for (p = string; *p; p++) {
	if (*p == '\n') {
	    *q++ = '\\';
	    *q++ = 'n';
	    continue;
	} else if (*p == '\\') {
	    *q++ = '\\';
	    /* fall through */
	}
	*q++ = *p;
    }
    *q = '\0';

    return result;
}

