/*
 * xfonttool_stubs.c - Notify and event callback function stubs.
 * This file was generated by `gxv' from `xfonttool.G'.
 */

#include <stdio.h>
#include <sys/param.h>
#include <sys/types.h>
#include <xview/xview.h>
#include <xview/panel.h>
#include <xview/textsw.h>
#include <xview/xv_xrect.h>
#include <group.h>
#include "xfonttool_ui.h"

#include <xview/font.h>
#include <xview/cms.h>
#include <string.h>

#include "fonttool.h"
#include "options.h"
#include <xview/dragdrop.h>
#include <xview/cursor.h>
#include <gdd.h>

#include <stdlib.h>
#include <unistd.h>
#include <ctype.h>

    /* function prototypes: */
#include "ansi.h"

/* some declarations to shut gcc up a bit */
extern fprintf();
extern _flsbuf();
extern fputs();
extern int fclose();
extern sscanf();
extern perror();

#ifndef toupper
extern int toupper();
extern int tolower();
#endif

/* */

char *progname = (char *) "@(#) $Id: xfonttool_stubs.c,v 1.16 96/09/16 23:51:36 lee Exp Locker: lee $";
/* */

void		cbResizeMainWindow();
Attr_attribute	FIELD_KEY;
Attr_attribute	TIMER_KEY;
Attr_attribute	FONT_VIEW_KEY;
Attr_attribute	FontNameKey;
xfonttool_fcFontView_objects	*Xfonttool_fcFontView;
xfonttool_fcFontMatrix_objects	*Xfonttool_fcFontMatrix;
xfonttool_fcSaveFontList_objects	*Xfonttool_fcSaveFontList;
xfonttool_fcScanFontPath_objects	*Xfonttool_fcScanFontPath;
xfonttool_fcFontServerAdmin_objects	*Xfonttool_fcFontServerAdmin;
xfonttool_fFontSearch_objects	*Xfonttool_fFontSearch;

#define MAIN_WINDOW_PREFIX (char *) "xfonttool 0.2: "

#define MATCH_ANY (char *) "(Any)"
#define MATCH_BLANK (char *) "(None)"

/*
 * Global object definitions.
 */

static t_OneFont *Fonts;
static int fontCount;
char *ConstrainToTheseFields[14];
static Xv_opaque controlsForFonts[14];
static int selectedFamily = -1;
    /* This is for performance, because scrolling lists are too slow.
     * We remember which row was selected, and if the same row is selected
     * twice in a row, we don't do anything.
     * It's global because other things that might change the list need
     * to change it.  I should use client data really.  But it needs to
     * be fast so that the scrolling list callback can return in time
     * for a double click!
     */

#define SETKEY(control,field) \
    { \
	xv_set(Xfonttool_fFontSearch->control, XV_KEY_DATA, FIELD_KEY, field, \
	    NULL \
	); \
	controlsForFonts[field] = Xfonttool_fFontSearch->control; \
    }
    
static void
InitialiseFontKeys()
{
    SETKEY(sFoundry, FIELD_FOUNDRY);
    SETKEY(lFamily, FIELD_FAMILY);
    SETKEY(sWeight, FIELD_WEIGHT);
    SETKEY(sSlant, FIELD_SLANT);
    SETKEY(sSetWidth, FIELD_SETWIDTH);
    SETKEY(sAddedStyle, FIELD_ADDEDSTYLE);
    SETKEY(sSize, FIELD_PIXELSZ);
    SETKEY(sPointSize, FIELD_POINTSIZE);
    SETKEY(sResX, FIELD_RESX);
    SETKEY(sResY, FIELD_RESY);
    SETKEY(sSpacingType, FIELD_SPACE);
    SETKEY(sAverageWidth, FIELD_AVERAGEWIDTH);
    SETKEY(sCsetRegistry, FIELD_REGISTRY);
    SETKEY(sCsetEncoding, FIELD_ENCODING);
}

char *
updateConstraintPattern()
{
    static char Pattern[1000];
    int i;
    register char *p = Pattern;

    *p = '\0';
    for (i = 0; i < 14; i++) {
	if (ConstrainToTheseFields[i]) {
	    (void) sprintf(p, "-%s", ConstrainToTheseFields[i]);
	} else {
	    (void) strcpy(p, "-*");
	}

	while (*p) {
	    p++;
	}
    }

    if (Xfonttool_fFontSearch && Xfonttool_fFontSearch->tPattern) {
	xv_set(Xfonttool_fFontSearch->tPattern,
	    PANEL_VALUE, Pattern,
	    NULL
	);
    }
    return Pattern; /* oh dear -- this is wasted space really. */
}

static int
FieldsSatisfyConstraint(Fields)
    char **Fields;
{
    int i;

    for (i = 0; i < 14; i++) {
	if (Fields[i] && ConstrainToTheseFields[i]) {
	    char *a;

	    if (strcmp(Fields[i], MATCH_BLANK) == 0) {
		a = (char *) "";
	    } else if (strcmp(Fields[i], MATCH_ANY) == 0) {
		continue;
		/* Any matches everything... an Any on the user-specified
		 * fields means to ignore any constraint there.
		 */
	    } else {
		a = Fields[i];
	    }

	    if (strcmp(a, ConstrainToTheseFields[i]) != 0) {
		return 0;
	    }
	}
    }
    return 1;
}

static void
UpdateFontChoice(theField, theAttrs)
    int theField;
    char **theAttrs;
{
    Xv_opaque theChoice = controlsForFonts[theField];
    char *oldString = 0;

    xv_set(theChoice,
	ATTR_LIST, theAttrs,
	NULL
    );

    if (ConstrainToTheseFields[theField]) {
	int j;

	oldString = ConstrainToTheseFields[theField];
	if (oldString[0] == '\0') {
	    oldString = MATCH_BLANK;
	}

	for (j = 1; theAttrs[j]; j++) {
	    if (strcmp(oldString, theAttrs[j]) == 0) {

		/* NOTE: panel choice values are numbered from zero,
		 * but xv_get returns items numbered from one, so
		 * we have to subtract one here.
		 * I'm not sure if this is a bug...
		 */
		xv_set(theChoice,
		    PANEL_VALUE, j - 1,
		    PANEL_INACTIVE, FALSE,
		    NULL
		);
		break;
	    }
	}
	if (!theAttrs[j]) {
	    fprintf(stderr,
		"internal error: %s: %d: field %d/%s not found\n",
		__FILE__, __LINE__,
		theField,
		ConstrainToTheseFields[theField]
	    );
	    xv_set(theChoice,
		PANEL_VALUE, 1, /* guess */
		PANEL_INACTIVE, FALSE,
		NULL
	    );
	}
    } else {
	if (theAttrs[3] == 0) {
	    xv_set(theChoice,
		PANEL_VALUE, 1,
		PANEL_INACTIVE, TRUE,
		NULL
	    );
	} else {
	    xv_set(theChoice,
		PANEL_VALUE, 0,
		PANEL_INACTIVE, FALSE,
		NULL
	    );
	}
    }
}

/*
 *
 *
 *
 */

static void
SetScrollingListStrings(list, strings)
    Xv_opaque list;
    char **strings;
{
    xv_set(list,
	XV_SHOW, FALSE,
	PANEL_LIST_DELETE_ROWS,
	    0, (int) xv_get(list, PANEL_LIST_NROWS),
	NULL
    );

    xv_set(list,
	PANEL_LIST_INSERT_STRINGS, 1, &strings[1],
	NULL
    );

    xv_set(list,
	XV_SHOW, TRUE,
	NULL
    );
    return;
}

static char inListInsertCallback = 0;

static Notify_value
SelectFirstInFontList()
{
    int n;
    int i = 0;
    int ifInactive = FALSE;

    if (inListInsertCallback) {
	return NOTIFY_DONE; /* not ready yet */
    }

    n = (int) xv_get(Xfonttool_fFontSearch->lFamily, PANEL_LIST_NROWS);
    if (n < 1) {
	/* not ready yet */
	return NOTIFY_DONE;
    }

    /* turn the timer off */
    (void) notify_set_itimer_func(
	Xfonttool_fFontSearch->fFontSearch,
	NOTIFY_FUNC_NULL,
	ITIMER_REAL,
	NULL,
	NULL
    );

    /* If we've selected a font family,
     * the only things in the list will be
     * (Any)
     * and the family name, and we want to show the
     * family name selected.
     *
     * Otherwise, we haven't selected a font family, and so
     * we want to show (Any) selected.
     */
    if (n == 2) {
	i = 1;
	if (!ConstrainToTheseFields[FIELD_FAMILY]) {
	    /* grey the control out if there is only one value, and
	     * setting it to (Any) would make no difference
	     */
	    ifInactive = TRUE;
	}
    } else if (ConstrainToTheseFields[FIELD_FAMILY]) {
	char *s;

	for (i = 1; i < n; i++) {
	    s = (char *) xv_get(Xfonttool_fFontSearch->lFamily,
		PANEL_LIST_STRING, i
	    );

	    if (s && strcmp(s, ConstrainToTheseFields[FIELD_FAMILY]) == 0) {
		break;
	    }
	}

	if (i >= n) {
	     /* not found */
	     i = 0;
	}
    }

    xv_set(Xfonttool_fFontSearch->lFamily,
	PANEL_LIST_SELECT, i, TRUE,
	PANEL_INACTIVE, ifInactive,
	NULL
    );

    selectedFamily = (int) xv_get(Xfonttool_fFontSearch->lFamily,
	PANEL_LIST_FIRST_SELECTED
    );

    return NOTIFY_DONE;
}

static void
arrangeForListToBeSet()
{
    struct itimerval timething;

    /* We'll wait a while and then try and set the selected item on
     * the scrolling Family list.  If it's too soon, we'll wait some more.
     * It is too soon if we are still in the PANEL_LIST_SELECT callback,
     * because we get a core dump there in XView 3.2...
     */
    timething.it_value.tv_usec = 60;
    timething.it_value.tv_sec = 0;
    timething.it_interval.tv_usec = 40;
    timething.it_interval.tv_sec = 0;

    (void) notify_set_itimer_func(
	Xfonttool_fFontSearch->fFontSearch,
	SelectFirstInFontList,
	ITIMER_REAL,
	&timething,
	NULL
    );
}

static int
compareStrings(s1p, s2p)
    char **s1p, **s2p;
{
    return strcmp(*s1p, *s2p);
}

static void
sortStringArray(Attrs)
    char **Attrs;
{
    if (Attrs[0] && Attrs[1]) {
	int n;

	/* count the number of strings */
	for (n = 0; Attrs[n]; n++)
	    ;
	
	qsort(Attrs, n, sizeof(char *), compareStrings);
    }
}

static void
updateFontControls(changedField)
    int changedField;
{
    int i;
    int field;
    char **Fields[14];
    char *SelectionSoFar[14];
    int fontsMatching = 0;

    for (field = 0; field < 14; field++) {
	Fields[field] = (char **) malloc(sizeof(char *) * (fontCount + 4));
	if (field == FIELD_FAMILY) {
	    Fields[field][0] = (char *) PANEL_LIST_STRINGS;
	} else {
	    Fields[field][0] = (char *) PANEL_CHOICE_STRINGS;
	}

	Fields[field][1] = MATCH_ANY;
	Fields[field][2] = 0;
	Fields[field][3] = 0;

	SelectionSoFar[field] = 0;
    }

    for (i = 0; i < fontCount; i++) {
	t_OneFont *op;
	int addThisFont;

	op = &Fonts[i];

	addThisFont = FieldsSatisfyConstraint(op->Fields);

	if (addThisFont) {
	    ++fontsMatching;
	}

	for (field = 0; field < 14; field++) {
	    register char **fp;
	    char *VisibleRepresentation;

	    if (!op->Fields[field]) {
		/* erp, what would this mean?? */
		continue;
	    }

	    if (!*op->Fields[field]) {
		VisibleRepresentation = MATCH_BLANK;
	    } else {
		VisibleRepresentation = op->Fields[field];
	    }

	    if (!addThisFont) {
		char *tmp;
		int OK;

		/* If the font does not match, but would match
		 * if the current field had not been constrained,
		 * we want to add the value, so that you can remove
		 * a constraint by selceting another value directly.
		 * For example, if you select Slant->R, now Slant->I
		 * would not normally be in the list because it doesn't
		 * match any font with Slant = R.  But we leave
		 * Slant->I in the list, if changing Slant from R to I
		 * would leave some font sselected.  If there are no
		 * fonts matching all other constraints and with Slant I,
		 * we do not admit the value to this field.
		 *
		 * This algorithm is a little slow.  How could it
		 * be improved?  Let me know...
		 */

		if (!ConstrainToTheseFields[field]) {
		    /* the font doesn't match, and there is no constraint
		     * on this field to lift that might change things.
		     */
		    continue;
		}

		tmp = ConstrainToTheseFields[field];
		ConstrainToTheseFields[field] = 0;
		OK = FieldsSatisfyConstraint(op->Fields);
		ConstrainToTheseFields[field] = tmp;

		if (!OK) {
		    /* Even if there were no constraints on this field,
		     * this font would not match.  So, putting it into
		     * the menu for this font isn't going to be very
		     * helpful...
		     * selecting it would get you zero fonts matching.
		     */
		    continue;
		}
	    }

	    /* the 2 skips over PANEL_CHOICE_STRINGS and MATCH_ANY first */
	    for (fp = &Fields[field][2]; *fp; fp++) {
		if (strcmp(*fp, VisibleRepresentation) == 0) {
		    break;
		}
	    }
	    if (!*fp) {
		*fp = VisibleRepresentation;
		fp[1] = fp[2] = 0;
	    }
	}
    }


    /* Make the displayed font pattern be as specific as possible --
     * for example, if you've selected a font that only has an italic,
     * we'll put -i- in the appropriate field, so you can see that quickly.
     * This doesn't affect the constraint fields.
     */
    for (field = 0; field < 14; field++) {
	if (ConstrainToTheseFields[field]) {
	    SelectionSoFar[field] = ConstrainToTheseFields[field];
	} else if (Fields[field]) {
	    if (Fields[field][2] && !Fields[field][3]) {
		/* only one value */
		if (strcmp(Fields[field][2], MATCH_BLANK) == 0) {
		    SelectionSoFar[field] = (char *) "";
		} else {
		    SelectionSoFar[field] = Fields[field][2];
		}
	    } else {
		SelectionSoFar[field] = (char *) "*";
	    }
	}
    }

    {
	char tmp[1000];
	FieldsToFontName(tmp, SelectionSoFar);

	xv_set(Xfonttool_fFontSearch->tPattern, PANEL_VALUE, tmp, NULL);
    }

    /* Now update the actual font controls... */
    for (field = 0; field < 14; field++) {
	if (field == changedField) {
	    /* no need to update this one, as it hasn't changed */
	    continue;
	}

	if (field == FIELD_FAMILY) {
	    /* family is a scrolled list, and has to be done differently. */
	    SetScrollingListStrings(
		Xfonttool_fFontSearch->lFamily,
		Fields[field]
	    );
	} else {
	    /* sort the values -- but not the 1st one, which is the
	     * XView attribute, and not the 2nd one, which is (Any)
	     */
	    sortStringArray(&Fields[field][2]);

	    /* Now update the XView control: */
	    UpdateFontChoice(field, Fields[field]);
	}

	if (Fields[field]) {
	    free((char *) Fields[field]);
	}
    }

    {
	char tmp[1000];
	char *pattern = (char *)
		xv_get(Xfonttool_fFontSearch->tPattern, PANEL_VALUE);

	if (fontsMatching == 1) {
	    (void) sprintf(tmp, "one font matches %s", pattern);
	} else {
	    (void) sprintf(tmp, "%d fonts match %s", fontsMatching, pattern);
	}
	xv_set(Xfonttool_fFontSearch->fFontSearch,
	    FRAME_SHOW_FOOTER, TRUE,
	    FRAME_LEFT_FOOTER, tmp,
	    FRAME_RIGHT_FOOTER, "",
	    NULL
	);
    }

    /* Finally, set off a timer to update the Family scrolling list: */
    arrangeForListToBeSet();
}

void
SetConstraintFromString(string)
    char *string;
{
    char *Fields[14];
    int i;
    char *save = strdup(string);

    FontNameToFields(save, Fields);
	/* use a saved copy because FontNameToFields modifies the string */

    for (i = 0; i < 14; i++) {
	char *value;

	if (Fields[i]) {
	    if (strcmp(Fields[i], "*") == 0) {
		value = 0;
	    } else {
		value = strdup(Fields[i]);
	    }
	} else {
	    value = 0;
	}
	if (ConstrainToTheseFields[i]) {
	    free(ConstrainToTheseFields[i]);
	}
	ConstrainToTheseFields[i] = value;
    }
    free(save);
    updateConstraintPattern();
}

static void
InitialiseFontNames(pattern)
    char *pattern;
{
    t_OneFont *NewFonts;
    int oldFontCount = fontCount;
    Display *dpy = (Display *) xv_get(
	Xfonttool_fFontSearch->fFontSearch, XV_DISPLAY
    );

    NewFonts = 0;
    fontCount = GetFontNamesMatching(dpy, pattern, &NewFonts);
    if (fontCount) {
	if (Fonts) {
	    destroyFonts(Fonts, oldFontCount);
	}
	Fonts = NewFonts;
	SetConstraintFromString(pattern);
    } else {
	if (Xfonttool_fFontSearch && Xfonttool_fFontSearch->fFontSearch) {
	    xv_set(Xfonttool_fFontSearch->fFontSearch,
		FRAME_SHOW_FOOTER, TRUE,
		FRAME_LEFT_FOOTER, "No fonts matched",
		WIN_ALARM,
		NULL
	    );
	}
	return;
    }

    /* show the search results window */

    /* Update the window with matching fonts */
    updateFontControls(-1);

    /* the window size may have changed... */
    xv_set(Xfonttool_fFontSearch->group1,
	GROUP_LAYOUT, TRUE,
	NULL
    );
    xv_set(Xfonttool_fFontSearch->group2,
	GROUP_LAYOUT, TRUE,
	NULL
    );
    xv_set(Xfonttool_fFontSearch->group4,
	GROUP_LAYOUT, TRUE,
	NULL
    );
    xv_set(Xfonttool_fFontSearch->group35,
	GROUP_LAYOUT, TRUE,
	NULL
    );
    xv_set(Xfonttool_fFontSearch->group36,
	GROUP_LAYOUT, TRUE,
	NULL
    );
    xv_set(Xfonttool_fFontSearch->group37,
	GROUP_LAYOUT, TRUE,
	NULL
    );
    xv_set(Xfonttool_fFontSearch->group38,
	GROUP_LAYOUT, TRUE,
	NULL
    );

    window_fit(Xfonttool_fFontSearch->controls1);
    window_fit(Xfonttool_fFontSearch->fFontSearch);

    {
	char buffer[1000];

	(void) sprintf(buffer, "%s: %s", MAIN_WINDOW_PREFIX, pattern);
	xv_set(Xfonttool_fFontSearch->fFontSearch,
	    XV_LABEL, buffer,
	    NULL
	);
    }

}

static void
ConstrainToString(Field, Value)
    int Field;
    char *Value;
{
    if (Value) {
	if (strcmp(Value, MATCH_BLANK) == 0) {
	    Value = strdup("");
	} else if (strcmp(Value, MATCH_ANY) == 0) {
	    Value = 0;
	} else {
	    Value = strdup(Value);
	}
    }
    if (ConstrainToTheseFields[Field]) {
	if (Value && strcmp(ConstrainToTheseFields[Field], Value) == 0) {
	    free(Value);
	    return;
	}
	free(ConstrainToTheseFields[Field]);
    } else if (!Value) {
	/* neither is set, so nothing to do */
	return;
    }
    ConstrainToTheseFields[Field] = Value;
    updateConstraintPattern();
    updateFontControls(Field);
}


#ifdef MAIN

#define DEFAULT_PATTERN "-*-*-*-*-*-*-0-0-0-0-*-0-*-*"

static void
usage(name)
    char *name;
{
    extern void xv_usage(
#ifdef HAVE_PROTO
	char *name
#endif
    );

    fListOptions(stderr);
    fprintf(stderr, "\n\n");
    xv_usage(name);

    exit(2);
}

/*
 * Instance XV_KEY_DATA key.  An instance is a set of related
 * user interface objects.  A pointer to an object's instance
 * is stored under this key in every object.  This must be a
 * global variable.
 */
Attr_attribute	INSTANCE;

char *defaultPattern = (char *) DEFAULT_PATTERN;

int
main(argc, argv)
	int	argc;
	char	**argv;
{

	progname = argv[0];
	if (strrchr(progname, '/')) {
	    progname = strrchr(progname, '/');
	    progname++;
	}

	/*
	 * Initialize XView.
	 */
	xv_init(XV_INIT_ARGC_PTR_ARGV, &argc, argv,
	    XV_USAGE_PROC, usage,
	    XV_USE_LOCALE, TRUE,
	    NULL
	);

	INSTANCE = xv_unique_key();
	FIELD_KEY = xv_unique_key();
	TIMER_KEY = xv_unique_key();
	FONT_VIEW_KEY = xv_unique_key();
	FontNameKey = xv_unique_key();
	
	/*
	 * Initialize user interface components.
	 * Do NOT edit the object initializations by hand.
	 */
	Xfonttool_fFontSearch = xfonttool_fFontSearch_objects_initialize(NULL, NULL);
	Xfonttool_fcFontView = xfonttool_fcFontView_objects_initialize(NULL, Xfonttool_fFontSearch->fFontSearch);
	Xfonttool_fcSaveFontList = xfonttool_fcSaveFontList_objects_initialize(NULL, Xfonttool_fFontSearch->fFontSearch);
	Xfonttool_fcScanFontPath = xfonttool_fcScanFontPath_objects_initialize(NULL, Xfonttool_fFontSearch->fFontSearch);
	Xfonttool_fcFontServerAdmin = xfonttool_fcFontServerAdmin_objects_initialize(NULL, Xfonttool_fFontSearch->fFontSearch);
	Xfonttool_fcFontMatrix = xfonttool_fcFontMatrix_objects_initialize(NULL, Xfonttool_fFontSearch->fFontSearch);

	/* Associate font fields with user interface controls: */
	InitialiseFontKeys();

	SetUpFontViewProps(Xfonttool_fcFontView, Xfonttool_fcFontMatrix);

	if (parseOptions(argc, argv) < 0) {
	    exit(1);
	}

	defaultPattern = updateConstraintPattern();
	InitialiseFontNames(defaultPattern);
	updateFontControls(-1);

	/* Give a message about help */
	{
	    char *p;
	    char *msg = (char *) "use Help or F1 for explanations of controls";

	    p = (char *) xv_get(Xfonttool_fFontSearch->controls1, XV_HELP_DATA);

	    if (!p || !*p) {
		char *hp = getenv("HELPPATH");

		if (hp) {
		    fprintf(stderr,
			"%s: warning: help file %s not found in HELPPATH\n",
			progname, "xfonttool.hlp"
		    );
		    msg = (char *) "help file not found";
		} else {
		    (void) fprintf(stderr,
			"%s: warning: $HELPPATH not set: no online help\n",
			progname
		    );
		    msg = (char *) "$HELPPATH not set";
		}
	    }

	    xv_set(Xfonttool_fFontSearch->fFontSearch,
		FRAME_SHOW_FOOTER, TRUE,
		FRAME_RIGHT_FOOTER, msg,
		NULL
	    );
	}

#ifdef HAVE_FILE_CHOOSER
	xv_set(Xfonttool_fFontSearch->lFamily,
	    PANEL_LIST_DO_DBL_CLICK, TRUE,
	    NULL
	);
#endif

	/*
	 * Turn control over to XView.
	 */
	gdd_init_dragdrop(Xfonttool_fFontSearch->fFontSearch);
	xv_main_loop(Xfonttool_fFontSearch->fFontSearch);
	exit(0);
}

#endif

static void
CopyFieldAsPostScript(Field, Destinationp, Startp, Lengthp)
    char *Field;
    char **Destinationp;
    char **Startp;
    int *Lengthp;
{
    register char *q, *p;
    int atWordStart = 1;

    for (q = *Destinationp, p = Field; *p; p++) {

	if (q - *Startp >= *Lengthp - 1) {
	    int WhereWeWere = q - *Startp;

	    *Lengthp += 50;
	    *Startp = realloc(*Startp, *Lengthp);
	    q = &(*Startp)[WhereWeWere];
	}

	if (atWordStart) {
	    if (islower(*p)) {
		*q++ = toupper(*p);
	    } else {
		*q++ = *p;
	    }
	    atWordStart = 0;
	} else if (*p == ' ') {
	    atWordStart = 1;
	    /* but squash the space */
	} else {
	    *q++ = *p;
	}
    }
    *q = '\0';

    *Destinationp = q;
}

static char *
XLFDtoPostScriptName(dpy, xlfd, font)
    Display *dpy;
    char *xlfd;
    Xv_Font font;
{
    /* Turn
     * -fonthaus-celestia antiqua-medium-r-normal--0-0-0-0-p-0-iso8859-1
     * into
     * CelestiaAntiqua (FontHaus)
     *
     * TODO: use a database and font properties...
     *
     * NOTE: this routine returns a pointer to a static buffer.
     */
    
    static char *buffer;
    static int buflen = 0;
    char *q;
    char *Fields[14];
    char *freeMe;

    if (!buflen) {
	buflen = 200;
	buffer = malloc(buflen);
    }

    /* See if the font has the FACE_NAME property */
    if (font) {
	static Atom theAtom = 0;
	XFontStruct *xfont;
	int i;

	/* Note: fetching the XFontStruct will usually cause the font
	 * to be rendered, which is slow.  But we need to do that anyway
	 * in order to draw the sample.
	 */
	xfont = (XFontStruct *) xv_get(font, FONT_INFO);

	/* Now, we've got the font metrics, which may include the FACE_NAME
	 * property.  In order to look up a font property, we first need
	 * to turn the property name into an Atom (a 32-bit hash, usually),
	 * since the properties in the font arre stored as an array of
	 * (atom, value) pairs...
	 */
	if (!theAtom) {
	    /* Only do this once -- it needs a server round trip */
	    theAtom = XInternAtom(dpy, "FACE_NAME", 0);
	}

	/* Look for a property whose atom is that of "FACE_NAME": */

	/* Note: with the MIT X11 sample font server, the FACE_NAME
	 * property is not correctly NUL-terminated in the call to
	 * XInternAtom in the font server.  Apart from being a memory
	 * leak, it means that the font names may have trailing garbage.
	 * There's not much I can do about that, unfortunately.
	 */

	for (i = 0; i < xfont->n_properties; i++) {
	    if (xfont->properties[i].name == theAtom) {
		/* we've got a FACE_NAME property */
		char *s;

		s = (char *) XGetAtomName(
		    dpy,
		    (Atom) xfont->properties[i].card32
		);

		if (s && *s) {
		    /* We've found the property, so now we need to
		     * copy it and free the string that Xlib returned to us
		     */
		    int len;
		    char *p;

		    /* Try to work round a bug in the X11R6 Type 1 font 
		     * code that puts trailing garbage on the end of
		     * FACE_NAME by detecting common garbage:
		     */
		    for (p = s; *p; p++) {
			if (*p < ' ') {
			    *p = '\0';
			    break;
			}
		    }

		    len = (p - s) + 1;

		    /* ensure that there's room for the copy */
		    if (len > buflen) {
			buflen = len;
			buffer = realloc(buffer, buflen);
			if (!buffer) {
			    return s;
			}
		    }

		    /* save the string */
		    (void) strcpy(buffer, s);

		    /* free the original before we lose the handle */
		    XFree(s);

		    /* return the copy */
		    return buffer;
		} else {
		    /* we've found the property, but it can't be used */
		    break;
		}
	    }
	}
    }

    freeMe = strdup(xlfd);
    FontNameToFields(freeMe, Fields);

    q = buffer;

    /* First, the family name */
    CopyFieldAsPostScript(Fields[FIELD_FAMILY], &q, &buffer, &buflen);
    *q++ = '-';

    /* additional style */
    CopyFieldAsPostScript(Fields[FIELD_ADDEDSTYLE], &q, &buffer, &buflen);

    /* append the face */
    if (strcmp(Fields[FIELD_WEIGHT], "medium") != 0) {
	CopyFieldAsPostScript(Fields[FIELD_WEIGHT], &q, &buffer, &buflen);
    }

    switch (Fields[FIELD_SLANT][0]) {
    case 'o':
	(void) strcpy(q, "Oblique");
	while (*q) {
	    q++;
	}
	break;
    case 'i':
	(void) strcpy(q, "Italic");
	while (*q) {
	    q++;
	}
	break;
    case 'r':
    default:
	/* only copy Roman if there was no other style */

	if (q > buffer && q[-1] == '-') {
	    (void) strcpy(q, "Roman");
	    while (*q) {
		q++;
	    }
	}
	break;
    }

    if (strcmp(Fields[FIELD_FOUNDRY], MATCH_ANY) != 0) {
	*q++ = ' ';
	*q++ = '(';
	CopyFieldAsPostScript(Fields[FIELD_FOUNDRY], &q, &buffer, &buflen);
	*q++ = ')';
	*q = '\0';
    }

    (void) free(freeMe);
    return buffer;
}

static char *
makeWindowLabel(dpy, Prefix, Pattern, theFont)
    Display *dpy;
    char *Prefix;
    char *Pattern;
    Xv_Font theFont;
{
    char *result;
    char *PSName;

    /* Turn
     * -fonthaus-celestia antiqua-medium-r-normal--0-0-0-0-p-0-iso8859-1
     * into
     * Prefix: CelestiaAntiqua (FontHaus)
     */
    PSName = XLFDtoPostScriptName(dpy, Pattern, theFont);
    result = malloc(strlen(PSName) + strlen(Prefix));
    (void) sprintf(result, "%s%s", Prefix, PSName);

    return result;
}

/*
 * Notify callback function for `lFamily'.
 */
int
cbFamily(item, string, client_data, op, event, row)
	Panel_item	item;
	char		*string;
	Xv_opaque	client_data;
	Panel_list_op	op;
	Event		*event;
	int		row;
{
	xfonttool_fFontSearch_objects *ip = (xfonttool_fFontSearch_objects *) xv_get(item, XV_KEY_DATA, INSTANCE);
	int doDisplay = 0;
	
	/* Note: the list is readonly, so insert/delete shouldn't happen,
	 * I think.
	 */

	inListInsertCallback = 1;

	switch(op) {
	case PANEL_LIST_OP_DESELECT:
		break;

#ifdef HAVE_FILE_CHOOSER
	case PANEL_LIST_OP_DBL_CLICK:
		doDisplay = 1;
		/* fall through */
#endif
	case PANEL_LIST_OP_SELECT:
		if (row != selectedFamily) {
		    selectedFamily = row;
		    ConstrainToString(FIELD_FAMILY, string);
		}

		break;

	case PANEL_LIST_OP_VALIDATE:
		break;

	case PANEL_LIST_OP_DELETE:
		break;
	}

	if (doDisplay) {
	    char *Pattern = (char *) xv_get(ip->tPattern, PANEL_VALUE);

	    xfonttool_fcFontView_objects *fontView = findFontViewWindow();

	    xv_set(fontView->vftFontName,
		PANEL_VALUE, Pattern,
		NULL
	    );

	    UpdateFontViewTextField(fontView, WITHOUT_REPAINTING);
	    xv_set(fontView->fcFontView, XV_SHOW, TRUE, NULL);
	    UpdateFontViewTextField(fontView, DO_REPAINT);
	}

	inListInsertCallback = 0;
	
	/* gxv_start_connections DO NOT EDIT THIS SECTION */

	/* gxv_end_connections */

	return XV_OK;
}

/*
 * Notify callback function for `sFoundry'.
 */
void
cbFoundry(item, value, event)
	Panel_item	item;
	int		value;
	Event		*event;
{
	/* xfonttool_fFontSearch_objects *ip = (xfonttool_fFontSearch_objects *) xv_get(item, XV_KEY_DATA, INSTANCE); */
	
	ConstrainToString(FIELD_FOUNDRY, 
	    (char *) xv_get(item, PANEL_CHOICE_STRING, value)
	);
	
	/* gxv_start_connections DO NOT EDIT THIS SECTION */

	/* gxv_end_connections */

}

/*
 * Notify callback function for `sAddedStyle'.
 */
void
cbAddedStyle(item, value, event)
	Panel_item	item;
	int		value;
	Event		*event;
{
	/* xfonttool_fFontSearch_objects *ip = (xfonttool_fFontSearch_objects *) xv_get(item, XV_KEY_DATA, INSTANCE); */
	
	ConstrainToString(FIELD_ADDEDSTYLE, 
	    (char *) xv_get(item, PANEL_CHOICE_STRING, value)
	);
	
	/* gxv_start_connections DO NOT EDIT THIS SECTION */

	/* gxv_end_connections */

}

/*
 * Notify callback function for `sWeight'.
 */
void
cbSetWeight(item, value, event)
	Panel_item	item;
	int		value;
	Event		*event;
{
	/* xfonttool_fFontSearch_objects *ip = (xfonttool_fFontSearch_objects *) xv_get(item, XV_KEY_DATA, INSTANCE); */
	
	ConstrainToString(FIELD_WEIGHT,
	    (char *) xv_get(item, PANEL_CHOICE_STRING, value)
	);
	
	/* gxv_start_connections DO NOT EDIT THIS SECTION */

	/* gxv_end_connections */

}

/*
 * Notify callback function for `sSlant'.
 */
void
cbSetSlant(item, value, event)
	Panel_item	item;
	int		value;
	Event		*event;
{
	/* xfonttool_fFontSearch_objects *ip = (xfonttool_fFontSearch_objects *) xv_get(item, XV_KEY_DATA, INSTANCE); */
	
	ConstrainToString(FIELD_SLANT,
	    (char *) xv_get(item, PANEL_CHOICE_STRING, value)
	);
	
	/* gxv_start_connections DO NOT EDIT THIS SECTION */

	/* gxv_end_connections */

}

/*
 * Notify callback function for `sSetWidth'.
 */
void
cbSetSetWidth(item, value, event)
	Panel_item	item;
	int		value;
	Event		*event;
{
	/* xfonttool_fFontSearch_objects *ip = (xfonttool_fFontSearch_objects *) xv_get(item, XV_KEY_DATA, INSTANCE); */
	
	ConstrainToString(FIELD_SETWIDTH,
	    (char *) xv_get(item, PANEL_CHOICE_STRING, value)
	);
	
	/* gxv_start_connections DO NOT EDIT THIS SECTION */

	/* gxv_end_connections */

}

/*
 * Notify callback function for `bSearch'.
 */
void
cbbuttonSearch(item, event)
	Panel_item	item;
	Event		*event;
{
	/* xfonttool_fFontSearch_objects *ip = (xfonttool_fFontSearch_objects *) xv_get(item, XV_KEY_DATA, INSTANCE); */
	Display *dpy = (Display *) xv_get(
	    Xfonttool_fFontSearch->fFontSearch, XV_DISPLAY
	);
	int nPaths;
	char **Paths;
	
	if (!Xfonttool_fcScanFontPath) {
	    Xfonttool_fcScanFontPath = xfonttool_fcScanFontPath_objects_initialize(NULL, Xfonttool_fFontSearch->fFontSearch);

	}

	if ((int) xv_get(Xfonttool_fcScanFontPath->fcScanFontPath, XV_SHOW) == FALSE) {
	    int y;

	    xv_set(Xfonttool_fcScanFontPath->tDefaultPattern,
		PANEL_VALUE, defaultPattern,
		NULL
	    );

	    y = (int) xv_get(Xfonttool_fcScanFontPath->daniella, XV_Y) +
		(int) xv_get(Xfonttool_fcScanFontPath->daniella, XV_HEIGHT);

	    xv_set(Xfonttool_fcScanFontPath->rosemary,
		XV_Y, y,
		NULL
	    );

	    window_fit(Xfonttool_fcScanFontPath->fcScanFontPath);
	}

	Paths = XGetFontPath(dpy, &nPaths);
	if (!Paths || !nPaths) {
	    fprintf(stderr, "eek - no font path!\n");
	    fprintf(stderr, "use \"xset fp default\" to get a new one!\n");
	    exit(1);
	}

	{
	    int i;
	    char **Strings;

	    /* Change the contents of the scrolling list to show the
	     * font path.
	     * Changing scrolling lists is a bit tricky: we hide the list
	     * first, so that you don't see it deleting things one by one.
	     * We then make up an attribute list that we can pass so we can
	     * add all the strings quickly.  There's a better way to do
	     * this in XView 3.2, but that isn't included in OpenWindows 3.0
	     * on SunOS 4, which is still widespread.
	     * Or was, when I wrote this code way back in August 1996.
	     */

	    xv_set(Xfonttool_fcScanFontPath->lFontPath,
		XV_SHOW, FALSE,
		NULL
	    );

	    i = (int) xv_get(
		Xfonttool_fcScanFontPath->lFontPath, PANEL_LIST_NROWS
	    );

	    xv_set(Xfonttool_fcScanFontPath->lFontPath,
		XV_SHOW, FALSE,
		PANEL_LIST_DELETE_ROWS, 0, i,
		NULL
	    );

	    Strings = (char **) malloc(sizeof(char **) * (nPaths + 2));
		/* +2 for the STRINGS attribute and the trailing NULL */

	    Strings[0] = (char *) PANEL_LIST_STRINGS;
	    for (i = 0; i < nPaths; i++) {
		Strings[i + 1] = Paths[i];
	    }
	    Strings[i + 1] = NULL;

	    xv_set(Xfonttool_fcScanFontPath->lFontPath,
		ATTR_LIST, Strings,
		NULL
	    );

	    xv_set(Xfonttool_fcScanFontPath->lFontPath,
		XV_SHOW, TRUE,
		NULL
	    );

	    if (nPaths > 0) {
		xv_set(Xfonttool_fcScanFontPath->sfptCurrentFontPathEntry,
		    PANEL_VALUE, Strings[1],
		    NULL
		);
		checkForFontServer(Strings[1]);
	    }

	    free((char *) Strings);
	}
	XFreeFontPath(Paths);

	/* gxv_start_connections DO NOT EDIT THIS SECTION */

	xv_set(Xfonttool_fcScanFontPath->fcScanFontPath, XV_SHOW, TRUE, NULL);
	
	/* gxv_end_connections */

}

/*
 * Notify callback function for `bReset'.
 */
void
cbbuttonReset(item, event)
	Panel_item	item;
	Event		*event;
{
	/* xfonttool_fFontSearch_objects *ip = (xfonttool_fFontSearch_objects *) xv_get(item, XV_KEY_DATA, INSTANCE); */
	
	int i;

	for (i = 0; i < 14; i++) {
	    if (ConstrainToTheseFields[i]) {
		free(ConstrainToTheseFields[i]);
	    }
	    ConstrainToTheseFields[i] = 0;
	}
	updateConstraintPattern();
	updateFontControls(-1);
	
	/* gxv_start_connections DO NOT EDIT THIS SECTION */

	/* gxv_end_connections */

}

/*
 * Notify callback function for `sSpacingType'.
 */
void
cbSetSpacingType(item, value, event)
	Panel_item	item;
	int		value;
	Event		*event;
{
	/* xfonttool_fFontSearch_objects *ip = (xfonttool_fFontSearch_objects *) xv_get(item, XV_KEY_DATA, INSTANCE); */
	
	ConstrainToString(FIELD_SPACE,
	    (char *) xv_get(item, PANEL_CHOICE_STRING, value)
	);
	
	/* gxv_start_connections DO NOT EDIT THIS SECTION */

	/* gxv_end_connections */

}

/*
 * Notify callback function for `sCsetRegistry'.
 */
void
cbSetRegistry(item, value, event)
	Panel_item	item;
	int		value;
	Event		*event;
{
	/* xfonttool_fFontSearch_objects *ip = (xfonttool_fFontSearch_objects *) xv_get(item, XV_KEY_DATA, INSTANCE); */
	
	ConstrainToString(FIELD_REGISTRY,
	    (char *) xv_get(item, PANEL_CHOICE_STRING, value)
	);
	
	/* gxv_start_connections DO NOT EDIT THIS SECTION */

	/* gxv_end_connections */

}

/*
 * Notify callback function for `sCsetEncoding'.
 */
void
cbSetEncoding(item, value, event)
	Panel_item	item;
	int		value;
	Event		*event;
{
	/* xfonttool_fFontSearch_objects *ip = (xfonttool_fFontSearch_objects *) xv_get(item, XV_KEY_DATA, INSTANCE); */
	
	ConstrainToString(FIELD_ENCODING,
	    (char *) xv_get(item, PANEL_CHOICE_STRING, value)
	);
	
	/* gxv_start_connections DO NOT EDIT THIS SECTION */

	/* gxv_end_connections */
}

static int
SaveListOfMatchingNamesToFile(path)
    char *path;
{
    FILE *f;
    int i;

    /* TODO: better error handling, with a dialogue */
    if (!path || !*path) {
	fprintf(stderr, "empty path in SaveListOfMatchingNamesToFile!\n");
	return -1;
    }

    f = fopen(path, "w");
    if (!f) {
	perror(path);
	return -1;
    }

    for (i = 0; i < fontCount; i++) {
	if (FieldsSatisfyConstraint(Fonts[i].Fields)) {
	    fprintf(f, "%s\n", Fonts[i].FullName);
	}
    }

    fclose(f);
    return 0;
}

/**** File chooser for saving the list of matched fonts.. ****/
#ifdef HAVE_FILE_CHOOSER
# include <xview/file_chsr.h>

static File_chooser saver;
static char madeSaver = 0;

static int
fileChooserFilterFunction(
    fc,
    path,
    stats,
    matched,
    glyph,
    client_data,
    mask_glyph
)
    File_chooser fc;
    char *path;
    struct stat *stats;
    File_chooser_op matched;
    Server_image *glyph;
    Xv_opaque client_data;
    Server_image *mask_glyph;
{
    return FILE_CHOOSER_ACCEPT;
}

static void
notifyOnFCSave(fc, path, file, client_data)
    File_chooser fc;
    char *path;
    char *file;
    Xv_opaque client_data;
{
    if (SaveListOfMatchingNamesToFile(path) < 0) {
	xv_set(Xfonttool_fFontSearch->fFontSearch,
	    WIN_ALARM,
	    NULL
	);
    } else {
	xv_set(fc,
	    XV_SHOW, FALSE,
	    NULL
	);
    }
}

#endif /* HAVE_FILE_CHOOSER */

/*
 * Notify callback function for `button1'.
 */
void
cbbuttonList(item, event)
	Panel_item	item;
	Event		*event;
{
	/* xfonttool_fFontSearch_objects *ip = (xfonttool_fFontSearch_objects *) xv_get(item, XV_KEY_DATA, INSTANCE); */
	
#ifdef HAVE_FILE_CHOOSER
	/* make a file chooser */
	if (!madeSaver) {
	    madeSaver = 1;
	    saver = (File_chooser) xv_create(
		Xfonttool_fFontSearch->fFontSearch, FILE_CHOOSER_SAVE_DIALOG,
		XV_LABEL, "Font View: Save Matching Names",
		FILE_CHOOSER_NOTIFY_FUNC, notifyOnFCSave,
		FILE_CHOOSER_FILTER_FUNC, fileChooserFilterFunction,
		NULL
	    );
	}
	xv_set(saver,
	    XV_SHOW, TRUE,
	    NULL
	);

#else
	/* No font chooser, use the Noddy version instead */
	if (!Xfonttool_fcSaveFontList) {
	    Xfonttool_fcSaveFontList = xfonttool_fcSaveFontList_objects_initialize(NULL, Xfonttool_fFontSearch->fFontSearch);
	    xv_set(Xfonttool_fcSaveFontList->priscilla,
		PANEL_DEFAULT_ITEM, Xfonttool_fcSaveFontList->sflbSave,
		NULL
	    );
	}
	xv_set(Xfonttool_fcSaveFontList->fcSaveFontList,
	    XV_SHOW, TRUE,
	    NULL
	);
#endif
	/* gxv_start_connections DO NOT EDIT THIS SECTION */

	/* gxv_end_connections */

}

/*
 * Notify callback function for `sSize'.
 */
void
cbSetSize(item, value, event)
	Panel_item	item;
	int		value;
	Event		*event;
{
	/* xfonttool_fFontSearch_objects *ip = (xfonttool_fFontSearch_objects *) xv_get(item, XV_KEY_DATA, INSTANCE); */
	
	ConstrainToString(FIELD_PIXELSZ,
	    (char *) xv_get(item, PANEL_CHOICE_STRING, value)
	);
	
	/* gxv_start_connections DO NOT EDIT THIS SECTION */

	/* gxv_end_connections */

}

/*
 * Notify callback function for `sPointSize'.
 */
void
cbSetPointSize(item, value, event)
	Panel_item	item;
	int		value;
	Event		*event;
{
	/* xfonttool_fFontSearch_objects *ip = (xfonttool_fFontSearch_objects *) xv_get(item, XV_KEY_DATA, INSTANCE); */
	
	ConstrainToString(FIELD_POINTSIZE,
	    (char *) xv_get(item, PANEL_CHOICE_STRING, value)
	);
	
	/* gxv_start_connections DO NOT EDIT THIS SECTION */

	/* gxv_end_connections */

}

/*
 * Notify callback function for `sResX'.
 */
void
cbSetResX(item, value, event)
	Panel_item	item;
	int		value;
	Event		*event;
{
	/* xfonttool_fFontSearch_objects *ip = (xfonttool_fFontSearch_objects *) xv_get(item, XV_KEY_DATA, INSTANCE); */
	
	ConstrainToString(FIELD_RESX,
	    (char *) xv_get(item, PANEL_CHOICE_STRING, value)
	);
	
	/* gxv_start_connections DO NOT EDIT THIS SECTION */

	/* gxv_end_connections */

}

/*
 * Notify callback function for `sResY'.
 */
void
cbSetResY(item, value, event)
	Panel_item	item;
	int		value;
	Event		*event;
{
	/* xfonttool_fFontSearch_objects *ip = (xfonttool_fFontSearch_objects *) xv_get(item, XV_KEY_DATA, INSTANCE); */
	
	ConstrainToString(FIELD_RESY,
	    (char *) xv_get(item, PANEL_CHOICE_STRING, value)
	);
	
	/* gxv_start_connections DO NOT EDIT THIS SECTION */

	/* gxv_end_connections */

}

/*
 * Notify callback function for `sAverageWidth'.
 */
void
cbSetAverageWidth(item, value, event)
	Panel_item	item;
	int		value;
	Event		*event;
{
	/* xfonttool_fFontSearch_objects *ip = (xfonttool_fFontSearch_objects *) xv_get(item, XV_KEY_DATA, INSTANCE); */
	
	ConstrainToString(FIELD_AVERAGEWIDTH,
	    (char *) xv_get(item, PANEL_CHOICE_STRING, value)
	);
	
	/* gxv_start_connections DO NOT EDIT THIS SECTION */

	/* gxv_end_connections */

}

typedef struct s_FontViewCacheEntry {
    xfonttool_fcFontView_objects *view;
    struct s_FontViewCacheEntry *Next;
} t_FontViewCacheEntry;

static t_FontViewCacheEntry *FontViewerCache = 0;

static xfonttool_fcFontView_objects *
findFontViewWindow()
{
    t_FontViewCacheEntry **fvcp;
    t_FontViewCacheEntry *result = 0;
    xfonttool_fcFontMatrix_objects *fontViewProps = 0;

    /* See if there is a visible, unpinned window, and, if so, use it: */
    for (fvcp = &FontViewerCache; *fvcp; fvcp = &(*fvcp)->Next) {
	if ((int) xv_get((*fvcp)->view->fcFontView, FRAME_CMD_PUSHPIN_IN) ==
						FALSE) {

	    /* It's unpinned, but is it visible? */
	    if ((int) xv_get((*fvcp)->view->fcFontView, XV_SHOW) == TRUE) {
		return (*fvcp)->view; /* yes */
	    } else if (!result) {
		/* no, it can't be seen, but remember it for possible
		 * later use...
		 */
		result = (*fvcp);
	    }
	}
    }

    /* There was no visible unpinned window... is there
     * an invisible one?
     */
    if (result) {
	xv_set(result->view->fcFontView,
	    XV_SHOW, TRUE,
	    NULL
	);
	return result->view;
    }

    /* No window was available, so we have to create one: */

    *fvcp = (t_FontViewCacheEntry *) malloc(sizeof(t_FontViewCacheEntry));
    (*fvcp)->Next = 0;
    (*fvcp)->view = xfonttool_fcFontView_objects_initialize(
	NULL, Xfonttool_fFontSearch->fFontSearch
    );

    fontViewProps = xfonttool_fcFontMatrix_objects_initialize(NULL,
	Xfonttool_fFontSearch->fFontSearch
    );
    Xfonttool_fcFontView = (*fvcp)->view;
    xv_set(Xfonttool_fcFontView->canvas1,
	XV_KEY_DATA, FontNameKey, "[unset]",
	NULL
    );

    /* The first time, we put the view window next to the main window...*/
    if (fvcp == &FontViewerCache) {
	/* TODO: move this to a separate function */
	Window xwin;
	Rect me;
	Display *dpy = (Display *)
	    xv_get(Xfonttool_fcFontView->fcFontView, XV_DISPLAY);
	Window root, parent, *kids;
	unsigned int nkids;
	int leftBorderWidth = 0;
	int rightBorderWidth = 0;
	int titleBarHeight = 0;
	int bottomBorderWidth = 0;
	int doReposition = 0;
	int newx = 0, newy = 0;

#define PRINTRECT(S, r) fprintf(stderr, "%s: tl (%d, %d), width %d, ht %d\n", S, r.r_left, r.r_top, r.r_width, r.r_height)

	/* Get the window parent, to find its size.  The window parent is
	 * decorated by the window manager, so that way we can find the
	 * difference in size and posision, and deduce the size of the
	 * window decorations -- the title bar, the borders and resize handles.
	 */

	xwin = (Window) xv_get(Xfonttool_fFontSearch->fFontSearch, XV_XID);
	if (XQueryTree(dpy, xwin, &root, &parent, &kids, &nkids) != 0) {
	    XFree(kids);

	    if (parent) { /* aha!  now to find its size... */
		XWindowAttributes parentAtts, myAtts;

		if (XGetWindowAttributes(dpy, parent, &parentAtts) == 0) {
		    doReposition = 0;
		} else if (XGetWindowAttributes(dpy, xwin, &myAtts) != 0) {
		    /* the top left of my window is beneath the title bar
		     * and to the left of the left border:
		     */
		    leftBorderWidth = myAtts.x;
		    titleBarHeight = myAtts.y;

		    /* the right border is the difference in width,
		     * minus the amount taken up by the left border:
		     */
		    rightBorderWidth = parentAtts.width - myAtts.width;
		    rightBorderWidth -= leftBorderWidth;

		    /* bottom border is the remaining vertical space: */
		    bottomBorderWidth = parentAtts.height - myAtts.height;
		    bottomBorderWidth -= titleBarHeight;

		    /* When we position a window, the position is actually
		     * The top left corner of the window manager's frame:
		     */
		    newx = parentAtts.x;
		    newy = parentAtts.y + parentAtts.height;
		    doReposition = 1;
		}

		if (doReposition) {
		    /* Now see if at least half of the new window fits on
		     * the screen; if not, after all this wor, we decide not
		     * to do the repositioning!
		     *
		     * Do this by getting the size of the root window...:
		     */
		    if (XGetWindowAttributes(dpy, root, &myAtts) == 0) {
			doReposition = 0; /* what went wrong?? */
		    } else {
			frame_get_rect((*fvcp)->view->fcFontView, &me);

			if (newy + me.r_height / 2 > myAtts.height) {
/* fprintf(stderr, "too low\n"); */
			    doReposition = 0;
			}
		    }
		}
	    }
	}

	if (doReposition) {
	    xv_set((*fvcp)->view->fcFontView,
		XV_SHOW, TRUE,
		XV_X, newx,
		XV_Y, newy,
		NULL
	    );
	}
    }

    SetUpFontViewProps((*fvcp)->view, fontViewProps);

    return (*fvcp)->view;
}

/*
 * Notify callback function for `bView'.
 */
void
xfonttool_fFontSearch_bView_notify_callback(item, event)
	Panel_item	item;
	Event		*event;
{
	/* xfonttool_fFontSearch_objects *ip = (xfonttool_fFontSearch_objects *) xv_get(item, XV_KEY_DATA, INSTANCE); */
	char *Pattern;

	/* TODO: make a new instance if the pushpin is in */
	/* XXX */
	xfonttool_fcFontView_objects *view = findFontViewWindow();

	/* make a font name */
	Pattern = (char *) xv_get(Xfonttool_fFontSearch->tPattern, PANEL_VALUE);
	xv_set(view->vftFontName,
	    PANEL_VALUE, Pattern,
	    NULL
	);

	UpdateFontViewTextField(view, WITHOUT_REPAINTING);
	
	/* gxv_start_connections DO NOT EDIT THIS SECTION */

	xv_set(Xfonttool_fcFontView->fcFontView, XV_SHOW, TRUE, NULL);
	
	/* gxv_end_connections */

	UpdateFontViewTextField(view, DO_REPAINT);

}

static void
SetUpFontViewProps(fontView, fontViewProps)
    xfonttool_fcFontView_objects *fontView;
    xfonttool_fcFontMatrix_objects *fontViewProps;
{
    Menu goodmenu;

    /* how to find the font props window from the font view window: */
    xv_set(fontView->fcFontView,
	XV_KEY_DATA, FONT_VIEW_KEY, fontViewProps,
	NULL
    );

    /* the reverse link: */
    xv_set(fontViewProps->fcFontMatrix,
	XV_KEY_DATA, FONT_VIEW_KEY, fontView,
	NULL
    );

    /* make it so there's only one menu */
    goodmenu = (Menu) xv_get(fontView->fpbSampleText, PANEL_ITEM_MENU);
    if (goodmenu) {
	xv_set(fontView->canvas1,
	    WIN_MENU, goodmenu,
	    NULL
	);
    }
}

/*
 * Notify callback function for `vfbMatrix'.
 */
void
xfonttool_fcFontView_vfbMatrix_notify_callback(item, event)
	Panel_item	item;
	Event		*event;
{
	xfonttool_fcFontView_objects *ip = (xfonttool_fcFontView_objects *) xv_get(item, XV_KEY_DATA, INSTANCE);
	char *m = (char *) xv_get(ip->vftPointSize, PANEL_VALUE);
	xfonttool_fcFontMatrix_objects *fontViewProps;
	
	fontViewProps = (xfonttool_fcFontMatrix_objects *) xv_get(
	    ip->fcFontView, XV_KEY_DATA, FONT_VIEW_KEY
	);

	if (!fontViewProps) {
	    fontViewProps = xfonttool_fcFontMatrix_objects_initialize(NULL, Xfonttool_fFontSearch->fFontSearch);

	    SetUpFontViewProps(ip, fontViewProps);
	}

	setFieldsFromFontMatrix(ip, fontViewProps, m);

	/* create a default button on the FontProperties window: */
	xv_set(fontViewProps->henrietta,
	    PANEL_DEFAULT_ITEM, fontViewProps->mvbApply,
	    NULL
	);

	/* prevent the fontView dialogue from vanishing */
	xv_set(item,
	    PANEL_NOTIFY_STATUS, XV_ERROR,
	    NULL
	);

	Xfonttool_fcFontMatrix = fontViewProps;

	/* gxv_start_connections DO NOT EDIT THIS SECTION */

	xv_set(Xfonttool_fcFontMatrix->fcFontMatrix, XV_SHOW, TRUE, NULL);
	
	/* gxv_end_connections */

}

/*
 * Notify callback function for `mvbApply'.
 */
void
cbmvApply(item, event)
	Panel_item	item;
	Event		*event;
{
	xfonttool_fcFontMatrix_objects *ip = (xfonttool_fcFontMatrix_objects *) xv_get(item, XV_KEY_DATA, INSTANCE);
	xfonttool_fcFontView_objects *fontView;

	fontView = (xfonttool_fcFontView_objects *) xv_get(ip->fcFontMatrix,
	    XV_KEY_DATA, FONT_VIEW_KEY
	);
	makeFontMatrix(fontView, ip);
	UpdateFontViewTextField(fontView, DO_REPAINT);

	/* gxv_start_connections DO NOT EDIT THIS SECTION */

	/* gxv_end_connections */

}

/*
 * Notify callback function for `mvbReset'.
 */
void
cbmvReset(item, event)
	Panel_item	item;
	Event		*event;
{
	xfonttool_fcFontMatrix_objects *ip = (xfonttool_fcFontMatrix_objects *) xv_get(item, XV_KEY_DATA, INSTANCE);
	
	xfonttool_fcFontView_objects *fontView;
	char *m;

	fontView = (xfonttool_fcFontView_objects *) xv_get(ip->fcFontMatrix,
	    XV_KEY_DATA, FONT_VIEW_KEY
	);

	m = (char *) xv_get(fontView->vftPointSize, PANEL_VALUE);
	
	setFieldsFromFontMatrix(fontView, ip, m);
	
	/* prevent the dialogue from vanishing */
	xv_set(item,
	    PANEL_NOTIFY_STATUS, XV_ERROR,
	    NULL
	);

	/* gxv_start_connections DO NOT EDIT THIS SECTION */

	/* gxv_end_connections */

}

/*
 * Background event callback function for `controls2'.
 * This is a function generated by guide to handle popup 
 * menu fvmFontView for control area controls2.
 */
void
xfonttool_fcFontView_controls2_background_handler(panel, event)
	Xv_opaque	panel;
	Event		*event;
{
	
	if (event_action(event) == ACTION_MENU && event_is_down(event)) {
		Menu	menu = (Menu) xv_get(panel, WIN_MENU);

		if (menu)
			menu_show(menu, panel, event, 0);
	}
}

void cbcanRepaint();

static void
UpdateFontViewTextField(view, doRepaint)
    xfonttool_fcFontView_objects *view;
    t_WhetherToRepaint doRepaint;
{
    char *theLongFontName = 0;
    char *Fields[14];
    char *p;
    int i;
    char dpix[30], dpiy[30];

    /* XXX make this take an argument, with NULL meaning the current one */

    if (!view || !view->vftFontName) {
	return;
    }

    p = (char *) xv_get(view->vftFontName, PANEL_VALUE);
    if (!p || !*p) {
	return;
    }
    theLongFontName = strdup(p);
    FontNameToFields(theLongFontName, Fields);

    p = (char *) xv_get(view->vftPointSize, PANEL_VALUE);
    if (p && *p) {
	Fields[FIELD_POINTSIZE] = p;
    }

    if (Xfonttool_fcFontMatrix) {
	i = (int) xv_get(Xfonttool_fcFontMatrix->vftDPIX, PANEL_VALUE);
	(void) sprintf(dpix, "%d", i);
	i = (int) xv_get(Xfonttool_fcFontMatrix->vftDPIY, PANEL_VALUE);
	(void) sprintf(dpiy, "%d", i);
	Fields[FIELD_RESX] = dpix;
	Fields[FIELD_RESY] = dpiy;
    } else {
	Fields[FIELD_RESX] = Fields[FIELD_RESY] = (char *) "100";
    }


    {
	char buffer2[1000];
	FieldsToFontName(buffer2, Fields);
	xv_set(view->vftFontName,
	    PANEL_VALUE, buffer2,
	    NULL
	);
    }

    if (doRepaint == DO_REPAINT) {
	Xv_window pw;

	CANVAS_EACH_PAINT_WINDOW(view->canvas1, pw) {
	    cbcanRepaint(
		view->canvas1,
		pw,
		xv_get(view->canvas1, XV_DISPLAY),
		xv_get(pw, XV_XID),
		(Xv_xrectlist *) 0
	    );
	} CANVAS_END_EACH;
    }

    if (theLongFontName) {
	free(theLongFontName);
    }
}

static GC gc;

/* Our own little font cache, needed mostly because the
 * X Window System doesn't do font cacheing at all, or at
 * least, most implementations don't!
 */
typedef struct {
    char *pattern;
    Font font;
    int usageCount;
} t_fontCache;

#define INITIAL_CACHE_SIZE 6
static int CacheAllocatedSize = 0;
static t_fontCache *fontCache;
static int fontsInCache = 0;

static void
OneLessFontInUse(name)
    char *name;
{
    int i;

    for (i = 0; i < fontsInCache; i++) {
	if (fontCache[i].pattern) {
	    if (strcmp(fontCache[i].pattern, name) == 0) {
		if (fontCache[i].usageCount) {
		    --fontCache[i].usageCount;
		}
		return;
	    }
	}
    }
    /* the font wasn't in use, but don't complain */
}

static Font
FindFontFromCache(object, name)
    Xv_opaque object; /* any window or frame */
    char *name;
{
    Font theFont = (Font) 0;
    int i;
    int unusedSlot = -1;

    for (i = 0; i < fontsInCache; i++) {
	if (fontCache[i].pattern) {
	    if (strcmp(fontCache[i].pattern, name) == 0) {
		++fontCache[i].usageCount;
		return fontCache[i].font;
	    }
	}

	if (unusedSlot < 0 && fontCache[i].usageCount == 0) {
	    /* not in use, remember that in case we need it later */
	    unusedSlot = i;
	}
    }

    if (i < CacheAllocatedSize) {
	/* there's room in the cache for one more font, so don't
	 * free a font and reuse it:
	 */
	unusedSlot = i;
    }

    /* OK, if we get here, the font is not in the cache.
     * Hence, we need to make a new one.
     */
    theFont = (Font) xv_find(object, FONT, FONT_NAME, name, NULL);

    if (theFont) {
	/* We have made a new font; let's store it in the cache.
	 * If the cache is full, we will grow the cache.
	 */
	
	if (CacheAllocatedSize == 0) {
	    CacheAllocatedSize = INITIAL_CACHE_SIZE;
	    fontCache = (t_fontCache *) malloc(
		sizeof(t_fontCache) * CacheAllocatedSize
	    );
	    if (!fontCache) {
		/* can't keep the cache */
		CacheAllocatedSize = 0;
		return theFont;
	    }
	    unusedSlot = 0;
	    fontCache[unusedSlot].pattern = (char *) 0;
	    fontCache[unusedSlot].font = (Font) 0;
	    fontCache[unusedSlot].usageCount = 0;
	}

	if (unusedSlot < 0) {
	    /* in this case we need to make the cache larger */
	    unusedSlot = CacheAllocatedSize;
	    CacheAllocatedSize += INITIAL_CACHE_SIZE;
	    fontCache = (t_fontCache *) realloc(fontCache,
		sizeof(t_fontCache) * CacheAllocatedSize
	    );
	    if (!fontCache) {
		/* can't keep the cache */
		CacheAllocatedSize = 0;
		return theFont;
	    }
	    fontCache[unusedSlot].pattern = (char *) 0;
	    fontCache[unusedSlot].font = (Font) 0;
	    fontCache[unusedSlot].usageCount = 0;
	}

	if (fontCache[unusedSlot].pattern) {
	    free(fontCache[unusedSlot].pattern);
	}
	if (fontCache[unusedSlot].font) {
	    xv_destroy(fontCache[unusedSlot].font);
	}

	fontCache[unusedSlot].font = theFont;
	fontCache[unusedSlot].pattern = strdup(name);
	fontCache[unusedSlot].usageCount = 1;

	if (unusedSlot >= fontsInCache) {
	    fontsInCache = unusedSlot + 1;
	}
    }
    return theFont;
}

/*
* Repaint callback function for `canvas1'.
 */
void
cbcanRepaint(canvas, paint_window, display, xid, rects)
	Canvas		canvas;
	Xv_window	paint_window;
	Display		*display;
	Window		xid;
	Xv_xrectlist	*rects;
{
	static Xv_Font theFont = 0;
	char *Pattern;
	static char madeGC = 0;
	char *Sample;
	static short inRepaint = 0;
	xfonttool_fcFontView_objects *ip;
	static char deferGlyphsWorks = 1;
	int triedDefer = 0;

	if (inRepaint) {
	    return;
	}

	ip = (xfonttool_fcFontView_objects *) xv_get(canvas, XV_KEY_DATA, INSTANCE);

	++inRepaint;

	xv_set(ip->fcFontView,
	    FRAME_BUSY, TRUE,
	    NULL
	);

	/* see if we were previously displaying a font, and, if so,
	 * reduce its usage count by one...
	 * most likely we'll allocate the same font again next time round,
	 * but our font cache is designed to handle that -- it does not
	 * actually free a font until it goes to reuse that slot.
	 */
	Pattern = (char *) xv_get(canvas, XV_KEY_DATA, FontNameKey);

	if (Pattern) {
	    OneLessFontInUse(Pattern);
	    free(Pattern);
	    Pattern = NULL;
	    xv_set(canvas,
		XV_KEY_DATA, FontNameKey, Pattern,
		NULL
	    );
	}

	Sample = (char *)
		xv_get(ip->fptSampleText, PANEL_VALUE);
	if (!Sample || !*Sample) {
	    Sample = (char *) "barefooted youths\\ngaily cavort";
	    xv_set(ip->fptSampleText,
		PANEL_VALUE, Sample,
		NULL
	    );
	}

	UpdateFontViewTextField(ip, WITHOUT_REPAINTING);
	Pattern = (char *) xv_get(ip->vftFontName,
	    PANEL_VALUE
	);
	if (!Pattern || !*Pattern) {
	    xv_set(ip->fcFontView,
		FRAME_LEFT_FOOTER, "No font specified",
		NULL
	    );
	    XClearWindow(display, xid);
	    goto repaintFinish;
	}

	/* if the server is running with "-deferglyhs all",
	 * we can ask for a font with a specific list of
	 * characters in it; we ask for only those characters
	 * that are actually in the sample.  For a short sample,
	 * such as the default ones, this can turn a ten of 15
	 * second wait into a one or three second wait...
	 *
	 * If the attempt to open the font fails, we
	 * remember that, and don't try the optimistion again.
	 */
	if (deferGlyphsWorks) {
	    char tmp[1000];
	    char used[256];
	    register unsigned char *p;
	    register int i;
	    int usedCount = 0;

	    for (i = 0; i < 256; i++) {
		used[i] = 0;
	    }

	    for (p = (unsigned char *) Sample; *p; p++) {
		i = *p;
		if (used[i] == 0) {
		    ++usedCount;
		    used[i] = 1;
		    if (usedCount > 150) {
			break;
		    }
		}
	    }

	    if (usedCount > 0 && usedCount < 150) {
		char tmp2[40];
		char *sep = (char *) NULL;

		(void) strcpy(tmp, Pattern);
		(void) strcat(tmp, "[");
		for (i = 0; i < 256; i++) {
		    if (used[i]) {
			int j;

			for (j = i; j < 256; j++) {
			    if (!used[j]) {
				break;
			    }
			}
			j--;
			if (i >= j) {
			    (void) sprintf(tmp2, "%d", i);
			} else {
			    (void) sprintf(tmp2, "%d_%d", i, j);
			    i = j;
			}
			if (sep) {
			    (void) strcat(tmp, sep);
			} else {
			    /* ready for next time: */
			    sep = (char *) " ";
			}
			(void) strcat(tmp, tmp2);
		    }
		}
		(void) strcat(tmp, "]");
		theFont = FindFontFromCache(canvas, tmp);
		triedDefer = 1;
		if (theFont) {
		    xv_set(canvas,
			XV_KEY_DATA, FontNameKey, strdup(tmp),
			NULL
		    );
		}
	    }
	}

	if (!theFont) {
	    theFont = FindFontFromCache(canvas, Pattern);
	    if (theFont && triedDefer) {
		/* We tried to open the font with a restricted
		 * character set and that failed, so this server
		 * probably doesn't support that...
		 * (or the font was just added to the font path,
		 * or the file changed, or something else fairly
		 * unlikely)
		 * So switch off the optimisation:
		 */
		deferGlyphsWorks = 0;
		xv_set(canvas,
		    XV_KEY_DATA, FontNameKey, strdup(Pattern),
		    NULL
		);
	    }
	}

	if (!theFont) {
	    char tmp[1000];

	    (void) sprintf(tmp, "bad font: %s", Pattern);
	    xv_set(ip->fcFontView,
		FRAME_SHOW_FOOTER, TRUE,
		FRAME_LEFT_FOOTER, tmp,
		FRAME_RIGHT_FOOTER, "",
		NULL
	    );
	    fprintf(stderr, "\nfont %s not found\n", Pattern);
	    XClearWindow(display, xid);

	    goto repaintFinish;
	} else {
	    /* the font was found, so clear any possible remaining
	     * "font not found" error message from the status footer:
	     */
	    xv_set(ip->fcFontView,
		FRAME_LEFT_FOOTER, "",
		NULL
	    );
	}

	if (!madeGC) {
	    XGCValues gcvalues;
	    Cms fcms;

	    fcms = (Cms) xv_get(canvas, WIN_CMS);
	    if (!fcms) {
		fcms = (Cms) xv_get(ip->fcFontView, WIN_CMS);
	    }

	    if (fcms) {
		gcvalues.background = xv_get(fcms,
		    CMS_PIXEL,
		    xv_get(canvas, WIN_BACKGROUND_COLOR)
		);
		gcvalues.foreground = xv_get(fcms,
		    CMS_PIXEL,
		    xv_get(canvas, WIN_FOREGROUND_COLOR)
		);
	    } else {
		fprintf(stderr, "Warning -- no colourmap... may look odd!\n");
		/* an informed guess: */
		gcvalues.foreground = CMS_CONTROL_COLORS;
		gcvalues.background = 0;
	    }

	    gcvalues.graphics_exposures = False;
	    gcvalues.font = (Font) xv_get(theFont, XV_XID);

	    gc = XCreateGC(
		display,
		RootWindow(display, DefaultScreen(display)),
		GCFont|GCGraphicsExposures|GCForeground|GCBackground,
		&gcvalues
	    );
	} else {
	    XGCValues gcvalues;

	    gcvalues.font = (Font) xv_get(theFont, XV_XID);
	    XChangeGC(display, gc, GCFont, &gcvalues);
	}

	{
	    int x, y;
	    Rect *Area;
	    Font_string_dims dimensions;
	    int canvasWidth = 0;
	    int canvasHeight = 0;
	    int changed = 0;
	    int sampleLen;
	    char *p;
	    int Widest = 0;
	    int nLines;
	    int vs = 0;
	    int topBorder = 10;

	    x = 10;
	    y = (int) xv_get(theFont, FONT_CHAR_HEIGHT, "Ab{~}");
	    y += topBorder;
		/* todo: use font bounding box instead;
		 * Note that if the font doesn't have an A in it,
		 * this might not work!
		 */

	    Area = (Rect *) xv_get(canvas, CANVAS_VIEWABLE_RECT, paint_window);

	    if (Area) {
		int Height = Area->r_height;
		if (Height > y) {
		    Height = y / 2;
		    /* if (Height > y) y = Height; */
		}
	    }

	    canvasHeight = (int) xv_get(canvas, XV_HEIGHT);
	    canvasWidth = (int) xv_get(canvas, XV_WIDTH);

	    for (nLines = 1, p = firstLine(Sample, &sampleLen);
		 p;
		 p = nextLine(Sample, p, &sampleLen)
	    ) {
		(void) xv_get(theFont, FONT_STRING_DIMS, Sample, &dimensions);

		if (y < dimensions.height * 1.2) {
		    /* 1.2 includes spacing between baselines */
		    y = dimensions.height * 1.2;
		}
		if (dimensions.width > Widest) {
		    Widest = dimensions.width;
		}
		++nLines;
	    }

	    /* the space between baselines */
	    vs = y;
	    y += topBorder; /* top border */

	    if (y * (nLines + 0.5) > canvasHeight) {
		canvasHeight = vs/2 + vs * nLines + topBorder;
		changed = 1;
	    } else if (canvasHeight > (vs/2 + vs * nLines + topBorder)) {
		int newHeight = vs/2 + vs * nLines + topBorder;
		if (Area && Area->r_height >= newHeight) {
		    /* make the paint window be the same height as the
		     * visible part of the canvas if it all fits,
		     * so that no scrolling is needed.
		     * Allow 0.5 vs in slop so that we don't resize
		     * more often than we need to.
		     */
		    canvasHeight = Area->r_height;
		} else {
		    canvasHeight = newHeight;
		}
		changed = 1;
	    }

	    if (Widest * 1.2 > canvasWidth) {
		canvasWidth = Widest * 1.2;
		changed = 1;
	    } else if (canvasWidth > Widest * 1.2) {
		if (Area && Area->r_width >= Widest * 1.2) {
		    canvasWidth = Area->r_width;
		} else {
		    canvasWidth = Widest;
		}
	    }

	    if (changed) {
		xv_set(canvas,
		    CANVAS_AUTO_SHRINK, FALSE,
		    CANVAS_AUTO_EXPAND, TRUE,
		    CANVAS_WIDTH, canvasWidth,
		    CANVAS_HEIGHT, canvasHeight,
		    NULL
		);
	    }

	    XClearWindow(display, xid);

	    /* draw the text a line at a time */
	    for (p = firstLine(Sample, &sampleLen);
		 p;
		 p = nextLine(Sample, p, &sampleLen)
	    ) {
		XDrawString(display, xid, gc, x, y, p, sampleLen);
		y += vs;
	    }
	}

	/* reset the window title */
	{
	    char *frameLabel = makeWindowLabel(
		display, "fontView: ", Pattern, theFont
	    );

	    xv_set(ip->fcFontView,
		XV_LABEL, frameLabel,
		NULL
	    );
	    (void) free(frameLabel);
	}


repaintFinish:

	/* gxv_start_connections DO NOT EDIT THIS SECTION */

	/* gxv_end_connections */

	/* Cleanup and return... */
	xv_set(ip->fcFontView,
	    FRAME_BUSY, FALSE,
	    NULL
	);
	--inRepaint;
	return;
}

/*
 * Drop callback function for `canvas1'.
 */
void
cbcanDroppedOn(item, event, drop_info)
	Xv_opaque	item;
	Event		*event;
	GDD_DROP_INFO	*drop_info;
{
	xfonttool_fcFontView_objects *ip = (xfonttool_fcFontView_objects *) xv_get(item, XV_KEY_DATA, INSTANCE);
	char *p;

	/* gdd_print_drop_info(drop_info); */

	/* Set the sample text to whatever we were given... */

	if (drop_info->data && drop_info->length) {
	    /* TODO: handle filename, too, for larger drops
	     */
	    p = EscapeString(drop_info->data);

	    xv_set(ip->fptSampleText,
		PANEL_VALUE, p,
		NULL
	    );

	    free(p);
	    UpdateFontViewTextField(ip, DO_REPAINT);
	}
	
	/* gxv_start_connections DO NOT EDIT THIS SECTION */

	/* gxv_end_connections */

}

/*
 * Notify callback function for `vftPointSize'.
 */
Panel_setting
cbvfSetPointSize(item, event)
	Panel_item	item;
	Event		*event;
{
	xfonttool_fcFontView_objects *ip = (xfonttool_fcFontView_objects *) xv_get(item, XV_KEY_DATA, INSTANCE);
	
	UpdateFontViewTextField(ip, DO_REPAINT);
	
	/* gxv_start_connections DO NOT EDIT THIS SECTION */

	/* gxv_end_connections */

	return panel_text_notify(item, event);
}

/*
 * Notify callback function for `vftDPIX'.
 */
Panel_setting
cbvfSetDPIX(item, event)
	Panel_item	item;
	Event		*event;
{
	/* int	value = (int) xv_get(item, PANEL_VALUE); */
	
	UpdateFontViewTextField(0, DO_REPAINT);
	
	/* gxv_start_connections DO NOT EDIT THIS SECTION */

	/* gxv_end_connections */

	return panel_text_notify(item, event);
}

/*
 * Notify callback function for `vftDPIY'.
 */
Panel_setting
cbvfSetDPIY(item, event)
	Panel_item	item;
	Event		*event;
{
	/* int	value = (int) xv_get(item, PANEL_VALUE); */
	
	UpdateFontViewTextField(0, DO_REPAINT);
	
	/* gxv_start_connections DO NOT EDIT THIS SECTION */

	/* gxv_end_connections */

	return panel_text_notify(item, event);
}

/*
 * Menu handler for `fmmSampleText'.
 */
Menu
cbfpSampleTextMenu(menu, op)
	Menu		menu;
	Menu_generate	op;
{
	xfonttool_fcFontView_objects *ip = (xfonttool_fcFontView_objects *)
					xv_get(menu, XV_KEY_DATA, INSTANCE);
	xfonttool_fcFontView_objects *fontView = ip;
	char *currentString;
	
	static char inHereAlready = 0;

	if (inHereAlready) {
	    return menu;
	}
	inHereAlready = 1;

	switch (op) {
	case MENU_DISPLAY:
		currentString = (char *) xv_get(
		    fontView->fptSampleText, PANEL_VALUE
		);

		if (currentString && *currentString) {
		    Menu_item item;
		    int i;

		    /* Note: xv_find dumps core. maybe because it's a
		     * toggle menu?
		     */
		    i = (int) xv_get(menu, MENU_NITEMS);
		    if (i > 20) {
			/* The first 5 items are default ones... */
			xv_set(menu, MENU_REMOVE, 5, NULL);
			--i;
		    }
		    for (i = (int) xv_get(menu, MENU_NITEMS); i > 0; i--) {
			char *p;

			item = (Menu_item) xv_get(menu, MENU_NTH_ITEM, i);
			p = (char *) xv_get(item, MENU_STRING);

			if (p && *p && strcmp(p, currentString) == 0) {
			    break;
			}
		    }

		    if (i == 0) {
			item = (Menu_item) xv_create(XV_NULL, MENUITEM,
			    MENU_STRING, strdup(currentString),
			    NULL
			);

			xv_set(menu,
			    MENU_APPEND_ITEM, item,
			    MENU_RELEASE,
			    NULL
			);
		    }

		    /* side effect: it has been created if necessary! */
		}

		break;

	case MENU_DISPLAY_DONE:
		break;

	case MENU_NOTIFY:
		
		{
		    Menu_item selectedItem;
		    char *p = 0;
		    
		    selectedItem = (Menu_item) xv_get(menu, MENU_SELECTED_ITEM);
		    if (selectedItem) {
			p = (char *) xv_get(selectedItem, MENU_STRING);
			if (p) {
			    xv_set(fontView->fptSampleText,
				PANEL_VALUE, p,
				NULL
			    );
			    UpdateFontViewTextField(fontView, DO_REPAINT);
			}
		    } else {
			fprintf(stderr, "nothing selected!\n");
		    }
		}

		/* gxv_start_connections DO NOT EDIT THIS SECTION */

		/* gxv_end_connections */

		break;

	case MENU_NOTIFY_DONE:
		break;
	}
	inHereAlready = 0;
	return menu;
}

static void
makeFontMatrix(fontView, fontViewProps)
    xfonttool_fcFontView_objects *fontView;
    xfonttool_fcFontMatrix_objects *fontViewProps;
{
    char tmp[100];
    char *p = tmp;
    char *xstr, *ystr;

    if (!fontView && !fontViewProps) {
	fprintf(stderr, "%s: internal error at %s: %d\n",
	    progname,
	    __FILE__, __LINE__
	);
	return;
    }

    if (!fontView) {
	fontView = (xfonttool_fcFontView_objects *)
	    xv_get(fontViewProps->fcFontMatrix, XV_KEY_DATA, FONT_VIEW_KEY);
    }

    if (!fontViewProps) {
	fontViewProps = (xfonttool_fcFontMatrix_objects *)
	    xv_get(fontView->fcFontView, XV_KEY_DATA, FONT_VIEW_KEY);
    }

    xstr = p = (char *) xv_get(fontViewProps->fptPointSizeX, PANEL_VALUE);
    if (!p || !*p) {
	xstr = p = (char *) "11.5";
	xv_set(fontViewProps->fptPointSizeX,
	    PANEL_VALUE, p,
	    NULL
	);
    }

    /* If x and y are identical, and there is no rotation, there is no
     * need to use a matrix
     */
    ystr = (char *) xv_get(fontViewProps->fptPointSizeY, PANEL_VALUE);
    if (!ystr || !*ystr) {
	ystr = xstr;
    }

    if (strcmp(ystr, xstr) == 0) {
	char *rot, *shear;
	int same = 0;
	/* see if the other values are all defaulted.  If so, keep the
	 * size field simple rather than using a matrix
	 */
	rot = (char *) xv_get(fontViewProps->fptRotation, PANEL_VALUE);
	shear = (char *) xv_get(fontViewProps->fptShearAngle, PANEL_VALUE);
	if (!rot && !shear) {
	    same = 1;
	} else {
	    if (!rot || !*rot) {
		rot = (char *) "0";
	    }

	    if (!shear || !*shear) {
		shear = (char *) "0";
	    }

	    if (strcmp(rot, shear) == 0) {
		same = 1;
	    } else {
		/* compare the result of converting to an exact number
		 * of decipoints and see if it's still the same
		 * since the syntax allows 12.0001 points in a matrix,
		 * but only decipoints are actually supposetd to be used
		 */
		float frot, fshear;
		char tmp1[100], tmp2[100];

		frot = atof(rot) * 10;
		fshear = atof(shear) * 10;
		(void) sprintf(tmp1, "%d", (int) frot);
		(void) sprintf(tmp2, "%d", (int) fshear);

		if (strcmp(tmp1, tmp2) == 0) {
		    same = 1;
		}
	    }
	}

	if (same) {
	    float f = atof(p);
	    int size = 10 * f;

	    (void) sprintf(tmp, "%d", size);
	    xv_set(fontView->vftPointSize, PANEL_VALUE, tmp, NULL);
	    return;
	}
    }

    tmp[0] = '[';
    tmp[1] = '\0';
    (void) strcat(tmp, p);

    p = (char *) xv_get(fontViewProps->fptRotation, PANEL_VALUE);
    if (!p || !*p) {
	p = (char *) "0";
	xv_set(fontViewProps->fptRotation,
	    PANEL_VALUE, p,
	    NULL
	);
    }
    (void) strcat(tmp, " ");
    (void) strcat(tmp, p);

    p = (char *) xv_get(fontViewProps->fptShearAngle, PANEL_VALUE);
    if (!p || !*p) {
	p = (char *) "0";
	xv_set(fontViewProps->fptShearAngle,
	    PANEL_VALUE, p,
	    NULL
	);
    }
    (void) strcat(tmp, " ");
    (void) strcat(tmp, p);

    p = (char *) xv_get(fontViewProps->fptPointSizeY, PANEL_VALUE);
    if (!p || !*p) {
	p = (char *) "11.5";
	xv_set(fontViewProps->fptPointSizeY,
	    PANEL_VALUE, p,
	    NULL
	);
    }
    (void) strcat(tmp, " ");
    (void) strcat(tmp, p);
    (void) strcat(tmp, "]");

    for (p = tmp; *p; p++) {
	/* you can't have - for -ve numbers, so ~ is used instead. */
	if (*p == '-') {
	    *p = '~';
	}
    }

    xv_set(fontView->vftPointSize, PANEL_VALUE, tmp, NULL);
    UpdateFontViewTextField(fontView, DO_REPAINT);
}

static void
setFieldsFromFontMatrix(fontView, fontViewProps, theMatrix)
    xfonttool_fcFontView_objects *fontView;
    xfonttool_fcFontMatrix_objects *fontViewProps;
    char *theMatrix;
{
    char px[100], py[100], rot[100], shear[100];
    char tmp[200];
    char *p;
    int nFound = 0;

    if (!fontView && !fontViewProps) {
	fprintf(stderr, "%s: internal error at %s: %d\n",
	    progname,
	    __FILE__, __LINE__
	);
	return;
    }

    if (!fontView) {
	fontView = (xfonttool_fcFontView_objects *)
	    xv_get(fontViewProps->fcFontMatrix, XV_KEY_DATA, FONT_VIEW_KEY);
    }

    if (!fontViewProps) {
	fontViewProps = (xfonttool_fcFontMatrix_objects *)
	    xv_get(fontView->fcFontView, XV_KEY_DATA, FONT_VIEW_KEY);
    }

    if (!theMatrix) {
	theMatrix = (char *) "11.5 0 0 11.5";
    }

    if (theMatrix[0] == '[') {
	++theMatrix;
    }

    (void) strcpy(tmp, theMatrix);
    for (p = tmp; *p; p++) {
	if (*p == '~') {
	    *p = '-';
	} else if (*p == ']') {
	    *p = '\0';
	    break;
	}
    }

    nFound = sscanf(tmp, "%s%s%s%s", px, rot, shear, py);

    if (nFound <= 1) {
	int i = atoi(theMatrix);
	if (i > 0) {
	    if (i % 10) {
		(void) sprintf(px, "%d.%d", i / 10, i %10);
		(void) sprintf(py, "%d.%d", i / 10, i %10);
	    } else {
		(void) sprintf(px, "%d", i / 10);
		(void) sprintf(py, "%d", i / 10);
	    }
	} else {
	    /* set defaults */
	    (void) strcpy(px, "11.5");
	    (void) strcpy(py, "11.5");
	}
	(void) strcpy(rot, "0");
	(void) strcpy(shear, "0");
	nFound = 4;
    }

    if (nFound < 4) {
	(void) strcpy(py, px);
    }

    if (nFound < 3) {
	(void) strcpy(shear, "0");
    }

    if (nFound < 2) {
	(void) strcpy(rot, "0");
    }

    xv_set(fontViewProps->fptPointSizeX,
	PANEL_VALUE, px,
	NULL
    );

    xv_set(fontViewProps->fptRotation,
	PANEL_VALUE, rot,
	NULL
    );

    xv_set(fontViewProps->fptShearAngle,
	PANEL_VALUE, shear,
	NULL
    );

    xv_set(fontViewProps->fptPointSizeY,
	PANEL_VALUE, py,
	NULL
    );

    /* ensure that the values are both correct: */
    makeFontMatrix(fontView, fontViewProps);
}

/*
 * Notify callback function for `fptPointSizeX'.
 */
Panel_setting
fpcbSetPointSizeX(item, event)
	Panel_item	item;
	Event		*event;
{
	xfonttool_fcFontMatrix_objects *ip = (xfonttool_fcFontMatrix_objects *) xv_get(item, XV_KEY_DATA, INSTANCE);
	xfonttool_fcFontView_objects *fontView;
	
	fontView = (xfonttool_fcFontView_objects *)
		xv_get(ip->fcFontMatrix, XV_KEY_DATA, FONT_VIEW_KEY);

	makeFontMatrix(fontView, ip);
	
	/* gxv_start_connections DO NOT EDIT THIS SECTION */

	/* gxv_end_connections */

	return panel_text_notify(item, event);
}

/*
 * Notify callback function for `fptPointSizeY'.
 */
Panel_setting
fpcbSetPointSizeY(item, event)
	Panel_item	item;
	Event		*event;
{
	xfonttool_fcFontMatrix_objects *ip = (xfonttool_fcFontMatrix_objects *) xv_get(item, XV_KEY_DATA, INSTANCE);
	xfonttool_fcFontView_objects *fontView;
	
	fontView = (xfonttool_fcFontView_objects *)
		xv_get(ip->fcFontMatrix, XV_KEY_DATA, FONT_VIEW_KEY);

	makeFontMatrix(fontView, ip);
	
	/* gxv_start_connections DO NOT EDIT THIS SECTION */

	/* gxv_end_connections */

	return panel_text_notify(item, event);
}

/*
 * Notify callback function for `fptShearAngle'.
 */
Panel_setting
fpcbSetShearAngle(item, event)
	Panel_item	item;
	Event		*event;
{
	xfonttool_fcFontMatrix_objects *ip = (xfonttool_fcFontMatrix_objects *) xv_get(item, XV_KEY_DATA, INSTANCE);
	xfonttool_fcFontView_objects *fontView;
	
	fontView = (xfonttool_fcFontView_objects *)
		xv_get(ip->fcFontMatrix, XV_KEY_DATA, FONT_VIEW_KEY);

	makeFontMatrix(fontView, ip);
	
	/* gxv_start_connections DO NOT EDIT THIS SECTION */

	/* gxv_end_connections */

	return panel_text_notify(item, event);
}

/*
 * Notify callback function for `fptRotation'.
 */
Panel_setting
fpcbSetPointRotation(item, event)
	Panel_item	item;
	Event		*event;
{
	xfonttool_fcFontMatrix_objects *ip = (xfonttool_fcFontMatrix_objects *) xv_get(item, XV_KEY_DATA, INSTANCE);
	xfonttool_fcFontView_objects *fontView;
	
	fontView = (xfonttool_fcFontView_objects *)
		xv_get(ip->fcFontMatrix, XV_KEY_DATA, FONT_VIEW_KEY);
	makeFontMatrix(fontView, ip);
	
	/* gxv_start_connections DO NOT EDIT THIS SECTION */

	/* gxv_end_connections */

	return panel_text_notify(item, event);
}

/*
 * Notify callback function for `fptSampleText'.
 */
Panel_setting
cbfpSetSampleText(item, event)
	Panel_item	item;
	Event		*event;
{
	xfonttool_fcFontView_objects *ip = (xfonttool_fcFontView_objects *) xv_get(item, XV_KEY_DATA, INSTANCE);
	/* char *	value = (char *) xv_get(item, PANEL_VALUE); */
	
	UpdateFontViewTextField(ip, DO_REPAINT);
	
	/* gxv_start_connections DO NOT EDIT THIS SECTION */

	/* gxv_end_connections */

	return panel_text_notify(item, event);
}

/*
 * Notify callback function for `fvbSelect'.
 */
void
cbfvSelect(item, event)
	Panel_item	item;
	Event		*event;
{
	xfonttool_fcFontView_objects *ip = (xfonttool_fcFontView_objects *) xv_get(item, XV_KEY_DATA, INSTANCE);
	
	xv_set(ip->vftFontName,
	    PANEL_TEXT_SELECT_LINE,
	    NULL
	);

	/* prevent the dialogue from vanishing */
	xv_set(item,
	    PANEL_NOTIFY_STATUS, XV_ERROR,
	    NULL
	);
	
	/* gxv_start_connections DO NOT EDIT THIS SECTION */

	/* gxv_end_connections */

}

/*
 * Notify callback function for `sflbSave'.
 */
void
cbsflHandleSave(item, event)
	Panel_item	item;
	Event		*event;
{
	/* xfonttool_fcSaveFontList_objects *ip = (xfonttool_fcSaveFontList_objects *) xv_get(item, XV_KEY_DATA, INSTANCE); */
	
	char *dir, *file;
	int status;

	dir = (char *) xv_get(Xfonttool_fcSaveFontList->sfltDirectory,
	    PANEL_VALUE
	);
	file = (char *) xv_get(Xfonttool_fcSaveFontList->sfltFileName,
	    PANEL_VALUE
	);
	if (file[0] == '/') {
	    status = SaveListOfMatchingNamesToFile(file);
	} else {
	    char *path = malloc(strlen(dir) + strlen(file) + 2);
	    (void) sprintf(path, "%s/%s", dir, file);
	    status = SaveListOfMatchingNamesToFile(file);
	    free(path);
	}

	if (status < 0) {
	    /* prevent the dialogue from vanishing */
	    xv_set(item,
		PANEL_NOTIFY_STATUS, XV_ERROR,
		NULL
	    );
	}
	
	/* gxv_start_connections DO NOT EDIT THIS SECTION */

	/* gxv_end_connections */

}

/*
 * Event callback function for `fFontSearch'.
 */
Notify_value
xfonttool_fFontSearch_event_callback(win, event, arg, type)
	Xv_window	win;
	Event		*event;
	Notify_arg	arg;
	Notify_event_type type;
{
	/* xfonttool_fFontSearch_objects *ip = (xfonttool_fFontSearch_objects *) xv_get(win, XV_KEY_DATA, INSTANCE); */
	
	
	/* gxv_start_connections DO NOT EDIT THIS SECTION */
	/* gxv_end_connections */

	return notify_next_event_func(win, (Notify_event) event, arg, type);
}

/*
 * User-defined action for `fFontSearch'.
 */
void
cbResizeMainWindow(win, event, arg, type)
	Xv_window	win;
	Event		*event;
	Notify_arg	arg;
	Notify_event_type type;
{
	xfonttool_fFontSearch_objects *ip = (xfonttool_fFontSearch_objects *) xv_get(win, XV_KEY_DATA, INSTANCE);
	
	if (event_xevent(event)->xconfigure.send_event == TRUE) {
	    /* sent by the window manager, e.g. because we were moved */
	    return;
	}

	/* the window size may have changed... */
#ifdef WILD_FUN_TO_WATCH
	xv_set(ip->group1, GROUP_LAYOUT, TRUE, NULL);
	xv_set(ip->group2, GROUP_LAYOUT, TRUE, NULL);
	xv_set(ip->group4, GROUP_LAYOUT, TRUE, NULL);
	xv_set(ip->group35, GROUP_LAYOUT, TRUE, NULL);
	xv_set(ip->group36, GROUP_LAYOUT, TRUE, NULL);
#endif

	{
	    static int oldSpace;
	    int newSpace;
	    int nRows, oldRows;
	    int i;
	    int rowHeight;

	    /* The size of the window: */
	    newSpace = (int) xv_get(ip->fFontSearch, XV_HEIGHT);

	    if (!oldSpace) {
		/* This is the first time we've been called after being
		 * exposed...
		 */

		/* set the minimum size of the main window to be the current
		 * size, so that you can't mess it up by hiding the controls
		 */

		xv_set(ip->fFontSearch,
		    FRAME_MIN_SIZE,
			(int) xv_get(ip->fFontSearch, XV_WIDTH),
			(int) xv_get(ip->fFontSearch, XV_HEIGHT),
		    NULL
		);

		oldSpace = newSpace;
		return;
	    }

	    /* The height of the list of fonts: */
	    oldRows = (int) xv_get(ip->lFamily, PANEL_LIST_DISPLAY_ROWS);
	    if (oldRows <= 0) {
		return; /* oops */
	    }

	    rowHeight = (int) xv_get(ip->lFamily, PANEL_LIST_ROW_HEIGHT);

	    if (rowHeight <= 0) {
		/* what could this mean? */
		return;
	    }

	    i = (newSpace - oldSpace) / rowHeight;

	    /* i is the number of rows we can add or that we must subtract...
	     */
	    if (i <= 1 && i >= -1) {
		/* not enough room to do anything
		 */
		return;
	    }

	    oldSpace = newSpace; /* remember for next time */

	    nRows = oldRows + i;
	    if (nRows < 9) {
		nRows = 9;
	    }
	    xv_set(ip->lFamily,
		PANEL_LIST_DISPLAY_ROWS, nRows,
		NULL
	    );
	}

	xv_set(ip->group1, GROUP_LAYOUT, TRUE, NULL);
	xv_set(ip->group37, GROUP_LAYOUT, TRUE, NULL);
	xv_set(ip->group38, GROUP_LAYOUT, TRUE, NULL);

	window_fit(ip->controls1);
}

static void
checkForFontServer(string)
    char *string;
{
    if (string[0] == '/') {
	/* not a font server */
	xv_set(Xfonttool_fcScanFontPath->sfpbFindFontServer,
	    PANEL_INACTIVE, TRUE,
	    NULL
	);
    } else {
	xv_set(Xfonttool_fcScanFontPath->sfpbFindFontServer,
	    PANEL_INACTIVE, FALSE,
	    NULL
	);
    }
}

static char *CutItem = 0;

typedef enum {
    iwBefore,
    iwAfter,
    iwTop,
    iwBottom
} t_InsertWhere;

static void
handleInsertFontPath(menu, where)
    Menu menu;
    t_InsertWhere where;
{
    Menu parent;
    char *ItemToInsert = CutItem;
    int i = (int) xv_get(Xfonttool_fcScanFontPath->lFontPath,
	PANEL_LIST_FIRST_SELECTED
    );

    parent = (Menu) xv_get(menu, MENU_PARENT);
    if (!parent) {
	/* called from the button,
	 * not as a pull-right from Paste
	 */
	ItemToInsert = (char *)
		xv_get(Xfonttool_fcScanFontPath->sfptCurrentFontPathEntry,
	    PANEL_VALUE
	);
	if (!ItemToInsert) {
	    ItemToInsert = CutItem;
	}
    } else if (!ItemToInsert) {
	ItemToInsert = (char *)
		xv_get(Xfonttool_fcScanFontPath->sfptCurrentFontPathEntry,
	    PANEL_VALUE
	);
    }

    if (!ItemToInsert) {
	return;
    }

    /* set i to the row number of the new item */
    if (i < 0) i = 0;

    switch (where) {
    case iwBefore: --i; break;
    case iwAfter: i++; break;
    case iwTop: i = 0; break;
    case iwBottom:
	i = (int) xv_get(Xfonttool_fcScanFontPath->lFontPath,
	    PANEL_LIST_NROWS
	);
	break;
    }

    if (i < 0) {
	/* e.g. insert before the first item */
	i = 0;
    }

    xv_set(Xfonttool_fcScanFontPath->lFontPath,
	PANEL_LIST_INSERT, i,
	PANEL_LIST_STRING, i, ItemToInsert,
	NULL
    );
}

/*
 * Menu handler for `sfpmInsert'.
 */
Menu
sfpcbmInsert(menu, op)
	Menu		menu;
	Menu_generate	op;
{
	switch (op) {
	case MENU_DISPLAY:
		break;

	case MENU_DISPLAY_DONE:
		break;

	case MENU_NOTIFY:
	    {
		/* Insert into the font path */

		Menu selectedItem;
		t_InsertWhere Where = (t_InsertWhere) iwBottom;
	
		selectedItem = (Menu_item) xv_get(menu, MENU_SELECTED_ITEM);

		if (selectedItem) {
		    char *p;

		    p = (char *) xv_get(selectedItem, MENU_STRING);
		    if (p && *p) {
			if (strcmp(p, "Before") == 0) {
			    Where = iwBefore;
			} else if (strcmp(p, "After") == 0) {
			    Where = iwAfter;
			} else if (strcmp(p, "Top") == 0) {
			    Where = iwTop;
			} else if (strcmp(p, "Bottom") == 0) {
			    Where = iwBottom;
			}

			handleInsertFontPath(menu, Where);
		    }
		}

		/* prevent the dialogue from vanishing */
		xv_set(menu,
		    MENU_NOTIFY_STATUS, XV_ERROR,
		    NULL
		);


		/* gxv_start_connections DO NOT EDIT THIS SECTION */

		/* gxv_end_connections */

		break;
	    }

	case MENU_NOTIFY_DONE:
		break;
	}
	return menu;
}

static void
handleEditFontPath(menu, doCopy, doDelete)
    Menu menu;
    int doCopy;
    int doDelete;
{
    int i = (int) xv_get(Xfonttool_fcScanFontPath->lFontPath,
	PANEL_LIST_FIRST_SELECTED
    );

    if (i == -1) {
	/* TODO: better error handling */
	fprintf(stderr,
	    "%s: edit.Cut: error: no selection\n",
	    progname
	);
	return;
    }

    if (doCopy) {
	if (CutItem) {
	    free(CutItem);
	    CutItem = 0;
	}

	CutItem =
	    (char *) xv_get(Xfonttool_fcScanFontPath->lFontPath,
	    PANEL_LIST_STRING, i
	);
	if (CutItem) {
	    CutItem = strdup(CutItem);
	}
    }

    if (doDelete) {
	xv_set(Xfonttool_fcScanFontPath->lFontPath,
	    PANEL_LIST_DELETE, i,
	    NULL
	);
    }
}

/*
 * Menu handler for `sfpmEdit'.
 */
Menu
sfpmcbEdit(menu, op)
	Menu		menu;
	Menu_generate	op;
{
	switch (op) {
	case MENU_DISPLAY:
		break;

	case MENU_DISPLAY_DONE:
		break;

	case MENU_NOTIFY:
		{
		    Menu selectedItem;
		    char *p = 0;
		    int doCut = 0;
		    int doCopy = 0;
	    
		    selectedItem = (Menu_item) xv_get(menu, MENU_SELECTED_ITEM);

		    if (selectedItem) {
			p = (char *) xv_get(selectedItem, MENU_STRING);
		    }

		    if (p && *p) {
			if (strcmp(p, "Cut") == 0) {
			    doCopy = 1;
			    doCut = 1;
			} else if (strcmp(p, "Copy") == 0) {
			    doCopy = 1;
			} else if (strcmp(p, "Paste") == 0) {
			    /* already handled in the Insert menu */
			} else if (strcmp(p, "Delete") == 0) {
			    doCut = 1;
			} else {
			    fprintf(stderr,
				"%s: edit: internal error: selected [%s]\n",
				progname, p
			    );
			}
		    }

		    if (doCopy || doCut) {
			handleEditFontPath(menu, doCopy, doCut);
		    }
		}
		
		/* gxv_start_connections DO NOT EDIT THIS SECTION */

		/* gxv_end_connections */

		/* prevent the dialogue from vanishing */
		xv_set(menu,
		    MENU_NOTIFY_STATUS, XV_ERROR,
		    NULL
		);

		break;

	case MENU_NOTIFY_DONE:
		break;
	}
	return menu;
}

/*
 * Menu handler for `sfpmSetFontPath'.
 */
Menu
sfpmcbSetFontPath(menu, op)
	Menu		menu;
	Menu_generate	op;
{
	int changed = 0;
	
	switch (op) {
	case MENU_DISPLAY:
		break;

	case MENU_DISPLAY_DONE:
		break;

	case MENU_NOTIFY:
		{
		    Menu selectedItem;
		    char *p = 0;
	    
		    selectedItem = (Menu_item) xv_get(menu, MENU_SELECTED_ITEM);

		    if (selectedItem) {
			p = (char *) xv_get(selectedItem, MENU_STRING);
		    }

		    if (p && *p) {
			if (strcmp(p, "To List Shown") == 0) {
			    Display *dpy = (Display *) xv_get(
				Xfonttool_fFontSearch->fFontSearch, XV_DISPLAY
			    );
			    char **Strings;
			    int n;
			    int i;

			    n = (int) xv_get(
				Xfonttool_fcScanFontPath->lFontPath,
				PANEL_LIST_NROWS
			    );
			    Strings = (char **) malloc(
				sizeof(char *) * (n + 1)
			    );
			    if (!Strings) {
				fprintf(stderr, "%s: out of memory!\n",
				    progname
				);
				exit(1);
			    }
			    
			    for (i = 0; i < n; i++) {
				Strings[i] = (char *) xv_get(
				    Xfonttool_fcScanFontPath->lFontPath,
				    PANEL_LIST_STRING, i
				);
			    }
			    Strings[n] = 0;

			    XSetFontPath(dpy, Strings, n);
			    changed = 1;

			} else if (strcmp(p, "To Default Path") == 0) {
			    Display *dpy = (Display *) xv_get(
				Xfonttool_fFontSearch->fFontSearch, XV_DISPLAY
			    );
			    char *Strings[1];

			    Strings[0] = 0;
			    XSetFontPath(dpy, Strings, 0);
			} else if (strcmp(p, "Update (rehash)") == 0) {
			    /* I am not sure what the xset program does
			     * when you say "xset fp rehash" and I can't
			     * access the code right now, so this is a
			     * place holder.
			     * It might or might not work...
			     */
			    int n;
			    Display *dpy = (Display *) xv_get(
				Xfonttool_fFontSearch->fFontSearch, XV_DISPLAY
			    );
			    char **Strings = XGetFontPath(dpy, &n);

			    if (n) {
				XSetFontPath(dpy, Strings, n);
			    }

			    XFreeFontPath(Strings);
			    changed = 1;

			} else {
			    fprintf(stderr,
				"%s: internal error: unknown setfp action %s\n",
				progname, p
			    );
			}
		    }
		}

		if (changed) {
		    char *msg = (char *) "Press Match to regenerate the font list";
		    xv_set(Xfonttool_fcScanFontPath->fcScanFontPath,
			FRAME_SHOW_FOOTER, TRUE,
			FRAME_LEFT_FOOTER, msg,
			NULL
		    );
		} else {
		    xv_set(Xfonttool_fcScanFontPath->fcScanFontPath,
			FRAME_LEFT_FOOTER, "",
			NULL
		    );
		}

		/* prevent the dialogue from vanishing */
		xv_set(menu,
		    MENU_NOTIFY_STATUS, XV_ERROR,
		    NULL
		);
		
		/* gxv_start_connections DO NOT EDIT THIS SECTION */

		/* gxv_end_connections */

		break;

	case MENU_NOTIFY_DONE:
		break;
	}
	return menu;
}

/*
 * Notify callback function for `sfpbBrowse'.
 */
void
sfpcbBrowseFontDir(item, event)
	Panel_item	item;
	Event		*event;
{
	
	/* prevent the dialogue from vanishing */
	xv_set(item,
	    PANEL_NOTIFY_STATUS, XV_ERROR,
	    NULL
	);
	xv_set(Xfonttool_fcScanFontPath->fcScanFontPath,
	    FRAME_SHOW_FOOTER, TRUE,
	    FRAME_LEFT_FOOTER, "(Browse not implemented, sorry)",
	    NULL
	);

	/* create a file chooser */
	    /* This should look only for directories containing
	     * Families.list (OpenWindows 3.2 and earlier) or
	     * fonts.dir
	     */

	/* gxv_start_connections DO NOT EDIT THIS SECTION */

	/* gxv_end_connections */

}

/*
 * Notify callback function for `sfpbCheckFontPath'.
 */
void
sfpbcbRefreshPath(item, event)
	Panel_item	item;
	Event		*event;
{
	/* Fake a press to the button that shows the dialogue.. */
	cbbuttonSearch(item, event);

	/* prevent the dialogue from vanishing */
	xv_set(item,
	    PANEL_NOTIFY_STATUS, XV_ERROR,
	    NULL
	);

	/* gxv_start_connections DO NOT EDIT THIS SECTION */

	/* gxv_end_connections */

}

/*
 * Notify callback function for `sfpbScanForFonts'.
 */
void
sfpcbXListFonts(item, event)
	Panel_item	item;
	Event		*event;
{
	xfonttool_fcScanFontPath_objects *ip = (xfonttool_fcScanFontPath_objects *) xv_get(item, XV_KEY_DATA, INSTANCE);
	char *p = (char *) xv_get(
	    ip->tDefaultPattern,
	    PANEL_VALUE
	);

	if (!p || !*p) {
	    xv_set(ip->tDefaultPattern,
		PANEL_VALUE, defaultPattern,
		NULL
	    );
	    p = defaultPattern;
	}

	/* remove the message telling you to press this button: */
	xv_set(ip->fcScanFontPath,
	    FRAME_SHOW_FOOTER, TRUE,
	    FRAME_LEFT_FOOTER, "",
	    NULL
	);

	SetConstraintFromString(p);
	InitialiseFontNames(p);

	/* prevent the dialogue from vanishing */
	xv_set(item,
	    PANEL_NOTIFY_STATUS, XV_ERROR,
	    NULL
	);

	
	/* gxv_start_connections DO NOT EDIT THIS SECTION */

	/* gxv_end_connections */

}

static void
parseFontServer(string, dlog)
    char *string;
    xfonttool_fcFontServerAdmin_objects *dlog;
{
    char *p;
    char tmp[1000];
    char *start;

    /* The format is
     * tcp/host:port[/catalogues]
     * decnet/node::font$objname[/catalogues]
     * thief/anything
     * where "font" is a constant, and [/catalogues] is an optional
     * trailing string beginning with /.
     *
     * The thief protocol was invented by Liam Quin, and involves stealing
     * fonts when you need them by sending e-mail to usenet.  Don't worry,
     * it isn't implemented.
     */

    (void) strcpy(tmp, string);
    for (start = p = tmp; *p; p++) {
	if (*p == '/') {
	    *p = '\0';
	    break;
	}
    }

    if (strcmp(start, "tcp") == 0) {

	/* tcp/host:port[/catalogues] */

	xv_set(dlog->fstsTransport,
	    PANEL_VALUE, 0, /* tcp */
	    NULL
	);

	if (string[p - tmp]) {
	    start = &p[1];
	}

	/* now find a hostname */
	for (p = start; *p; p++) {
	    if (*p == ':') {
		*p = '\0';
		xv_set(dlog->fsstServerHost,
		    PANEL_VALUE, start,
		    NULL
		);
		*p = ':';
		break;
	    }
	}

	/* now a port number */
	if (*p) {
	    start = &p[1];
	}

	for (p = start; ;p++) {
	    if (!*p || *p == '/') {
		char c;
		int port;

		c = *p;
		port = atoi(start);
		if (port > 0) {
		    xv_set(dlog->fssnPort,
			PANEL_VALUE, port,
			NULL
		    );
		}
		if (c) {
		    /* step over the / */
		    p++;
		}
		break;
	    }
	}

	/* an optional catalogue */
	xv_set(dlog->fsttCatalogues,
	    PANEL_VALUE, p,
	    NULL
	);

	xv_set(dlog->simon,
	    XV_SHOW, TRUE,
	    NULL
	);
    } else if (strcmp(start, "decnet") == 0) {
	/* decnet/node::font$objname[/catalogues] */

	xv_set(dlog->fstsTransport1,
	    PANEL_VALUE, 1, /* decnet */
	    NULL
	);

	if (string[p - tmp]) {
	    start = &p[1];
	}

	/* now find the nodename */
	for (p = start; *p; p++) {
	    if (*p == ':') {
		*p = '\0';
		xv_set(dlog->fsstServerHost1,
		    PANEL_VALUE, start,
		    NULL
		);
		p++;
		break;
	    }
	}

	if (strncmp(p, ":font$", 6) == 0) {
	    p += 6;
	}

	/* now an object name */
	for (start = p; ;p++) {
	    if (!*p || *p == '/') {
		char c;

		c = *p;
		xv_set(dlog->fssnObjname,
		    PANEL_VALUE, start,
		    NULL
		);
		*p = c;
		if (c) {
		    /* step over the / */
		    p++;
		}
		break;
	    }
	}

	/* an optional catalogue */
	xv_set(dlog->fsttCatalogues1,
	    PANEL_VALUE, start,
	    NULL
	);

	xv_set(dlog->david,
	    XV_SHOW, TRUE,
	    NULL
	);

    } else if (strcmp(start, "thief") == 0) {
	xv_set(dlog->fstsTransport2,
	    PANEL_VALUE, 2, /* thief!  stop stealing fonts */
	    NULL
	);

	xv_set(dlog->yves,
	    XV_SHOW, TRUE,
	    NULL
	);
    } else if (*start) {
	/* TODO: better error handling */
	fprintf(stderr, "unknown server protocol %s\n", start);
    }
}

/*
 * Notify callback function for `sfpbFindFontServer'.
 */
void
xfonttool_fcScanFontPath_sfpbFindFontServer_notify_callback(item, event)
	Panel_item	item;
	Event		*event;
{
	xfonttool_fcScanFontPath_objects *ip = (xfonttool_fcScanFontPath_objects *) xv_get(item, XV_KEY_DATA, INSTANCE);
	char *p;

	p = (char *)
		xv_get(ip->sfptCurrentFontPathEntry,
	    PANEL_VALUE
	);

	if (p && *p) {
	    /* parse the fields and put them into the dialogue box */
	    parseFontServer(p, Xfonttool_fcFontServerAdmin);
	}
	/* prevent the dialogue from vanishing */
	xv_set(item, PANEL_NOTIFY_STATUS, XV_ERROR, NULL);

	/* gxv_start_connections DO NOT EDIT THIS SECTION */

	xv_set(Xfonttool_fcFontServerAdmin->fcFontServerAdmin, XV_SHOW, TRUE, NULL);
	
	/* gxv_end_connections */

}

/*
 * Notify callback function for `fstsTransport'.
 */
void
xfonttool_fcFontServerAdmin_fstsTransport_notify_callback(item, value, event)
	Panel_item	item;
	int		value;
	Event		*event;
{
	xfonttool_fcFontServerAdmin_objects *ip = (xfonttool_fcFontServerAdmin_objects *) xv_get(item, XV_KEY_DATA, INSTANCE);
	
	switch (value) {
	case 1:
	    xv_set(ip->fstsTransport1,
		PANEL_VALUE, 1,
		NULL
	    );
	    break;
	case 2:
	    xv_set(ip->fstsTransport2,
		PANEL_VALUE, 2,
		NULL
	    );
	    break;
	}
	
	/* gxv_start_connections DO NOT EDIT THIS SECTION */

	if (value == 1)
	{
		xv_set(Xfonttool_fcFontServerAdmin->david, XV_SHOW, TRUE, NULL);
	}
	
	if (value == 2)
	{
		xv_set(Xfonttool_fcFontServerAdmin->yves, XV_SHOW, TRUE, NULL);
	}
	
	/* gxv_end_connections */

}

/*
 * Notify callback function for `fstsTransport1'.
 */
void
xfonttool_fcFontServerAdmin_fstsTransport1_notify_callback(item, value, event)
	Panel_item	item;
	int		value;
	Event		*event;
{
	xfonttool_fcFontServerAdmin_objects *ip = (xfonttool_fcFontServerAdmin_objects *) xv_get(item, XV_KEY_DATA, INSTANCE);
	
	switch (value) {
	case 0:
	    xv_set(ip->fstsTransport,
		PANEL_VALUE, 0,
		NULL
	    );
	    break;
	case 2:
	    xv_set(ip->fstsTransport2,
		PANEL_VALUE, 2,
		NULL
	    );
	    break;
	}
	
	
	/* gxv_start_connections DO NOT EDIT THIS SECTION */

	if (value == 0)
	{
		xv_set(Xfonttool_fcFontServerAdmin->simon, XV_SHOW, TRUE, NULL);
	}
	
	if (value == 2)
	{
		xv_set(Xfonttool_fcFontServerAdmin->yves, XV_SHOW, TRUE, NULL);
	}
	
	/* gxv_end_connections */

}

/*
 * Notify callback function for `fstsTransport2'.
 */
void
xfonttool_fcFontServerAdmin_fstsTransport2_notify_callback(item, value, event)
	Panel_item	item;
	int		value;
	Event		*event;
{
	xfonttool_fcFontServerAdmin_objects *ip = (xfonttool_fcFontServerAdmin_objects *) xv_get(item, XV_KEY_DATA, INSTANCE); 
	
	switch (value) {
	case 0:
	    xv_set(ip->fstsTransport,
		PANEL_VALUE, 0,
		NULL
	    );
	    break;
	case 1:
	    xv_set(ip->fstsTransport1,
		PANEL_VALUE, 1,
		NULL
	    );
	    break;
	}
	
	/* gxv_start_connections DO NOT EDIT THIS SECTION */

	if (value == 0)
	{
		xv_set(Xfonttool_fcFontServerAdmin->simon, XV_SHOW, TRUE, NULL);
	}
	
	if (value == 1)
	{
		xv_set(Xfonttool_fcFontServerAdmin->david, XV_SHOW, TRUE, NULL);
	}
	
	/* gxv_end_connections */

}

/*
 * Notify callback function for `lFontPath'.
 */
int
fpcbFontPathList(item, string, client_data, op, event, row)
	Panel_item	item;
	char		*string;
	Xv_opaque	client_data;
	Panel_list_op	op;
	Event		*event;
	int		row;
{
	if (!string) {
	    return XV_OK;
	}
	
	switch(op) {
	case PANEL_LIST_OP_DESELECT:
		break;


#ifdef HAVE_FILE_CHOOSER
	case PANEL_LIST_OP_DBL_CLICK:
#endif
	case PANEL_LIST_OP_SELECT:
		xv_set(Xfonttool_fcScanFontPath->sfptCurrentFontPathEntry,
		    PANEL_VALUE, string,
		    NULL
		);

		checkForFontServer(string);
		break;

	case PANEL_LIST_OP_VALIDATE:
		break;

	case PANEL_LIST_OP_DELETE:
		break;
	}
	
	/* gxv_start_connections DO NOT EDIT THIS SECTION */

	/* gxv_end_connections */

	return XV_OK;
}

/*
 * Notify callback function for `sfptCurrentFontPathEntry'.
 */
Panel_setting
sfpcbCurrentFontPath(item, event)
	Panel_item	item;
	Event		*event;
{
	xfonttool_fcScanFontPath_objects *ip = (xfonttool_fcScanFontPath_objects *) xv_get(item, XV_KEY_DATA, INSTANCE);
	char *	value = (char *) xv_get(item, PANEL_VALUE);
	int i;
	
	checkForFontServer(value);

	/* change the selected value in the scrolling list */
	{
	    i = (int) xv_get(ip->lFontPath, PANEL_LIST_FIRST_SELECTED);

	    if (i != -1) {
		xv_set(ip->lFontPath,
		    PANEL_LIST_STRING, i, value,
		    NULL
		);
	    }
	}

	
	/* gxv_start_connections DO NOT EDIT THIS SECTION */

	/* gxv_end_connections */

	return panel_text_notify(item, event);
}

/*
 * Notify callback function for `fstbApply'.
 */
void
cbnFontPathTCPApply(item, event)
	Panel_item	item;
	Event		*event;
{
	char *p;
	xfonttool_fcFontServerAdmin_objects *ip = (xfonttool_fcFontServerAdmin_objects *) xv_get(item, XV_KEY_DATA, INSTANCE);
	
	char tmp[1000];
	(void) strcpy(tmp, "tcp/");

	p = (char *) xv_get(ip->fsstServerHost, PANEL_VALUE);

	(void) strcat(tmp, p);
	(void) strcat(tmp, ":");
	{
	    char port[60];
	    int i;

	    i = (int) xv_get(ip->fssnPort, PANEL_VALUE);
	    (void) sprintf(port, "%d", i);
	    (void) strcat(tmp, port);
	}

	p = (char *) xv_get(ip->fsttCatalogues, PANEL_VALUE);
	if (p && *p) {
	    (void) strcat(tmp, "/");
	    (void) strcat(tmp, p);
	}

	xv_set(Xfonttool_fcScanFontPath->sfptCurrentFontPathEntry,
	    PANEL_VALUE, tmp,
	    NULL
	);

	/* gxv_start_connections DO NOT EDIT THIS SECTION */

	/* gxv_end_connections */

}

/*
 * Notify callback function for `fstbReset'.
 */
void
cbFontServerTCPReset(item, event)
	Panel_item	item;
	Event		*event;
{
	/* xfonttool_fcFontServerAdmin_objects *ip = (xfonttool_fcFontServerAdmin_objects *) xv_get(item, XV_KEY_DATA, INSTANCE);
	
	fputs("xfonttool: cbFontServerTCPReset\n", stderr);
	*/
	
	/* gxv_start_connections DO NOT EDIT THIS SECTION */

	/* gxv_end_connections */

}

/*
 * Notify callback function for `fstbApply1'.
 */
void
cbFontPathDecNetApply(item, event)
	Panel_item	item;
	Event		*event;
{
	/*
	xfonttool_fcFontServerAdmin_objects *ip = (xfonttool_fcFontServerAdmin_objects *) xv_get(item, XV_KEY_DATA, INSTANCE);
	
	fputs("xfonttool: cbFontPathDecNetApply\n", stderr);
	*/
	
	/* gxv_start_connections DO NOT EDIT THIS SECTION */

	/* gxv_end_connections */

}

/*
 * Notify callback function for `fstbReset1'.
 */
void
cbFontPathDecNetReset(item, event)
	Panel_item	item;
	Event		*event;
{
	/*
	xfonttool_fcFontServerAdmin_objects *ip = (xfonttool_fcFontServerAdmin_objects *) xv_get(item, XV_KEY_DATA, INSTANCE);
	
	fputs("xfonttool: cbFontPathDecNetReset\n", stderr);
	*/
	
	/* gxv_start_connections DO NOT EDIT THIS SECTION */

	/* gxv_end_connections */

}

/*
 * Event callback function for `canvas1'.
 */
Notify_value
xfonttool_fcFontView_canvas1_event_callback(win, event, arg, type)
	Xv_window	win;
	Event		*event;
	Notify_arg	arg;
	Notify_event_type type;
{
	/* xfonttool_fcFontView_objects *ip = (xfonttool_fcFontView_objects *) xv_get(xv_get(win, CANVAS_PAINT_CANVAS_WINDOW), XV_KEY_DATA, INSTANCE); */
	
	/* gxv_start_connections DO NOT EDIT THIS SECTION */

	if (event_action(event) == ACTION_MENU && event_is_down(event)) {
		Menu	menu = (Menu) xv_get(win, WIN_MENU);

		if (menu)
			menu_show(menu, win, event, 0);
	}

	/* gxv_end_connections */

	return notify_next_event_func(win, (Notify_event) event, arg, type);
}


/*
 * Repaint callback function for `canvas2'.
 */
void
cbCharSetRepaint(canvas, paint_window, display, xid, rects)
	Canvas		canvas;
	Xv_window	paint_window;
	Display		*display;
	Window		xid;
	Xv_xrectlist	*rects;
{
	int i;
	int inGridMode = 1; /* the default */
	int bbx = 18; /* TODO: use real values */
	int bby = 22;

	fputs("xfonttool: cbCharSetRepaint\n", stderr);
	if (!gc) {
	    return;
	}

	/* get the font to display */

	/* work out the font bounding box */

	if (inGridMode) { /* draw all characters */
	    int xmargin, ymargin;
	    int height, width;
	    int padytop, padybot, padxleft, padxright;

	    xmargin = 8;
	    ymargin = 6;

	    padytop = 3; /* a little above centre */
	    padybot = 4;

	    padxleft = 4;
	    padxright = 4;

	    height = 8 * (bby + padytop + padybot);
	    width = 8 * (bbx + padxleft + padxright);
	    /* add 1 for the thickness of the 7 lines in each case: */
	    height += 7;
	    width += 7;

	    /* draw the grid */
	    for (i = 1; i < 8; i++) {
		int x1, y1;

		/* the vertical line */
		x1 = i * (bbx + padxleft + padxright);
		x1 += i - 1; /* for the rules */

		XDrawLine(display, xid, gc, 
		    x1, ymargin,
		    x1, height
		);

		/* the horizontal line */
		y1 = i * (bby + padytop + padybot);
		y1 += i - 1; /* for the rule thickness */

		XDrawLine(display, xid, gc, 
		    xmargin, y1,
		    width, y1
		);
	    }

	    /* draw the individual characters */
	    for (i = 0; i < 256; i++) { /* TODO: handle 16-bit fonts */
		/* calculate row and column */
		/* work out position */
		/* first, draw char bbox */
		/* now draw baseline, origin and width marks */
		/* now the character */
	    }
	} else { /* just draw a single character */

	    /* work out position */
	    /* first, draw char bbox */
	    /* now draw baseline, origin and width marks */
	    /* now the character */
	}

	
	/* gxv_start_connections DO NOT EDIT THIS SECTION */
	/* gxv_end_connections */

}
